SystemOrganization addCategory: #'Athens-Balloon'!
SystemOrganization addCategory: #'Athens-Bitmaps'!
SystemOrganization addCategory: #'Athens-Cairo'!
SystemOrganization addCategory: #'Athens-Core'!
SystemOrganization addCategory: #'Athens-Core-Paths'!
SystemOrganization addCategory: #'Athens-Matrices'!
SystemOrganization addCategory: #'Athens-Text'!
SystemOrganization addCategory: #'Athens-Examples'!

Trait named: #TCairoLibrary
	uses: {}
	category: 'Athens-Cairo'!

!TCairoLibrary classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 16:53'!
nbLibraryNameOrHandle
	^ '/opt/local/lib/libcairo.2.dylib'! !

!TCairoLibrary methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 16:52'!
nbLibraryNameOrHandle
	^ self class nbLibraryNameOrHandle
! !

!ImageMorph methodsFor: '*Athens' stamp: 'IgorStasenko 9/19/2011 16:10'!
drawOnAthensCanvas: aCanvas

	(aCanvas imageTransform: aCanvas pathTransform)
		translateBy: self innerBounds origin.
	
	aCanvas
		drawImage: image ! !

!Morph methodsFor: '*Athens' stamp: 'IgorStasenko 12/21/2011 13:56'!
drawOnAthensCanvas: anAthensCanvas 

	anAthensCanvas setPaint: self fillStyle.
	anAthensCanvas drawShape: self bounds.! !

!Morph methodsFor: '*Athens' stamp: 'IgorStasenko 9/19/2011 16:40'!
fullDrawOnAthensCanvas: anAthensCanvas 
	"Draw the full Morphic structure on the given Canvas"

	self visible ifFalse: [^ self].
	(anAthensCanvas isVisible: self fullBounds) ifFalse: [^self].
	(self hasProperty: #errorOnDraw) ifTrue: [^self "drawErrorOn: aCanvas" ].

	(anAthensCanvas isVisible: self bounds) ifTrue: [ anAthensCanvas draw: self ].
	
	submorphs isEmpty ifTrue: [^self].

	self clipSubmorphs ifTrue: [ | clip p1 p2 |
		
		"transform clipping bounds "
		clip := self clippingBounds.
		p1 := anAthensCanvas pathTransform transform: clip origin.
		p2 := anAthensCanvas pathTransform transform: clip corner.
		clip := Rectangle origin:  p1 corner: p2.		
		anAthensCanvas 
			clipBy: clip 
			during: [ submorphs reverseDo: [:m | anAthensCanvas fullDrawMorph: m ] ]
	] 
	ifFalse: [
		submorphs reverseDo: [:m | anAthensCanvas fullDrawMorph: m ]
	]
! !

SharedPool subclass: #AthensCairoDefs
	instanceVariableNames: ''
	classVariableNames: '	
	 CAIRO_FONT_SLANT_ITALIC CAIRO_FONT_SLANT_NORMAL CAIRO_FONT_SLANT_OBLIQUE CAIRO_FONT_TYPE_FT CAIRO_FONT_TYPE_QUARTZ CAIRO_FONT_TYPE_TOY CAIRO_FONT_TYPE_USER CAIRO_FONT_TYPE_WIN32 CAIRO_FONT_WEIGHT_BOLD CAIRO_FONT_WEIGHT_NORMAL CAIRO_FORMAT_A1 CAIRO_FORMAT_A8 CAIRO_FORMAT_ARGB32 CAIRO_FORMAT_INVALID CAIRO_FORMAT_RGB16_565 CAIRO_FORMAT_RGB24 CAIRO_LINE_CAP_BUTT CAIRO_LINE_CAP_ROUND CAIRO_LINE_CAP_SQUARE CAIRO_LINE_JOIN_BEVEL CAIRO_LINE_JOIN_MITER CAIRO_LINE_JOIN_ROUND CAIRO_OPERATOR_ADD CAIRO_OPERATOR_ATOP CAIRO_OPERATOR_CLEAR CAIRO_OPERATOR_COLOR_BURN CAIRO_OPERATOR_COLOR_DODGE CAIRO_OPERATOR_DARKEN CAIRO_OPERATOR_DEST CAIRO_OPERATOR_DEST_ATOP CAIRO_OPERATOR_DEST_IN CAIRO_OPERATOR_DEST_OUT CAIRO_OPERATOR_DEST_OVER CAIRO_OPERATOR_DIFFERENCE CAIRO_OPERATOR_EXCLUSION CAIRO_OPERATOR_HARD_LIGHT CAIRO_OPERATOR_HSL_COLOR CAIRO_OPERATOR_HSL_HUE CAIRO_OPERATOR_HSL_LUMINOSITY CAIRO_OPERATOR_HSL_SATURATION CAIRO_OPERATOR_IN CAIRO_OPERATOR_LIGHTEN CAIRO_OPERATOR_MULTIPLY CAIRO_OPERATOR_OUT CAIRO_OPERATOR_OVER CAIRO_OPERATOR_OVERLAY CAIRO_OPERATOR_SATURATE CAIRO_OPERATOR_SCREEN CAIRO_OPERATOR_SOFT_LIGHT CAIRO_OPERATOR_SOURCE CAIRO_OPERATOR_XOR CAIRO_STATUS_CLIP_NOT_REPRESENTABLE CAIRO_STATUS_DEVICE_ERROR CAIRO_STATUS_DEVICE_TYPE_MISMATCH CAIRO_STATUS_FILE_NOT_FOUND CAIRO_STATUS_FONT_TYPE_MISMATCH CAIRO_STATUS_INVALID_CLUSTERS CAIRO_STATUS_INVALID_CONTENT CAIRO_STATUS_INVALID_DASH CAIRO_STATUS_INVALID_DSC_COMMENT CAIRO_STATUS_INVALID_FORMAT CAIRO_STATUS_INVALID_INDEX CAIRO_STATUS_INVALID_MATRIX CAIRO_STATUS_INVALID_PATH_DATA CAIRO_STATUS_INVALID_POP_GROUP CAIRO_STATUS_INVALID_RESTORE CAIRO_STATUS_INVALID_SIZE CAIRO_STATUS_INVALID_SLANT CAIRO_STATUS_INVALID_STATUS CAIRO_STATUS_INVALID_STRIDE CAIRO_STATUS_INVALID_STRING CAIRO_STATUS_INVALID_VISUAL CAIRO_STATUS_INVALID_WEIGHT CAIRO_STATUS_LAST_STATUS CAIRO_STATUS_NEGATIVE_COUNT CAIRO_STATUS_NO_CURRENT_POINT CAIRO_STATUS_NO_MEMORY CAIRO_STATUS_NULL_POINTER CAIRO_STATUS_PATTERN_TYPE_MISMATCH CAIRO_STATUS_READ_ERROR CAIRO_STATUS_SUCCESS CAIRO_STATUS_SURFACE_FINISHED CAIRO_STATUS_SURFACE_TYPE_MISMATCH CAIRO_STATUS_TEMP_FILE_ERROR CAIRO_STATUS_USER_FONT_ERROR CAIRO_STATUS_USER_FONT_IMMUTABLE CAIRO_STATUS_USER_FONT_NOT_IMPLEMENTED CAIRO_STATUS_WRITE_ERROR cairo_font_slant_t cairo_font_type_t cairo_font_weight_t cairo_line_join_t cairo_operator_t cairo_status_t cairo_surface_t'
	poolDictionaries: ''
	category: 'Athens-Cairo'!

!AthensCairoDefs classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/16/2011 11:37'!
initialize

	"
	self initialize
	"

	self
		initialize_types; 
		initialize_cairo_format_t;
		initialize_cairo_font_slant_t;
		initialize_cairo_font_weight_t;
		initialize_cairo_font_type_t ;
		initialize_cairo_operator_t ;
		initialize_cairo_line_cap_t ;
		initialize_cairo_line_join_t;
		initialize_cairo_status_t.! !

!AthensCairoDefs classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/16/2011 11:24'!
initialize_cairo_font_slant_t

	"typedef enum _cairo_font_slant {"
    CAIRO_FONT_SLANT_NORMAL := 0.
    CAIRO_FONT_SLANT_ITALIC := 1.
    CAIRO_FONT_SLANT_OBLIQUE := 2

! !

!AthensCairoDefs classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/16/2011 11:24'!
initialize_cairo_font_type_t 
	"typedef enum _cairo_font_type {"
    CAIRO_FONT_TYPE_TOY := 0.
    CAIRO_FONT_TYPE_FT := 1.
    CAIRO_FONT_TYPE_WIN32 := 2.
    CAIRO_FONT_TYPE_QUARTZ := 3.
    CAIRO_FONT_TYPE_USER := 4.
	! !

!AthensCairoDefs classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/16/2011 11:24'!
initialize_cairo_font_weight_t

	"typedef enum _cairo_font_weight {"
    CAIRO_FONT_WEIGHT_NORMAL := 0.
    CAIRO_FONT_WEIGHT_BOLD := 1.
! !

!AthensCairoDefs classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/16/2011 11:24'!
initialize_cairo_format_t

	"enum cairo_format_t"
	CAIRO_FORMAT_INVALID :=  -1.
	CAIRO_FORMAT_ARGB32 :=  0.
	CAIRO_FORMAT_RGB24 := 1.
	CAIRO_FORMAT_A8 := 2.
	CAIRO_FORMAT_A1 := 3.
	CAIRO_FORMAT_RGB16_565 := 4! !

!AthensCairoDefs classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/16/2011 11:24'!
initialize_cairo_line_cap_t 
	"typedef enum _cairo_line_cap { "
    CAIRO_LINE_CAP_BUTT := 0.
    CAIRO_LINE_CAP_ROUND := 1.
    CAIRO_LINE_CAP_SQUARE := 2.
! !

!AthensCairoDefs classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/16/2011 11:24'!
initialize_cairo_line_join_t
"	typedef enum _cairo_line_join {"
    CAIRO_LINE_JOIN_MITER := 0.
    CAIRO_LINE_JOIN_ROUND := 1.
    CAIRO_LINE_JOIN_BEVEL := 2.

! !

!AthensCairoDefs classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/16/2011 11:24'!
initialize_cairo_operator_t 
"	typedef enum _cairo_operator {"
    CAIRO_OPERATOR_CLEAR := 0.

    CAIRO_OPERATOR_SOURCE:= 1.
    CAIRO_OPERATOR_OVER:= 2.
    CAIRO_OPERATOR_IN:= 3.
    CAIRO_OPERATOR_OUT:= 4.
    CAIRO_OPERATOR_ATOP:= 5.

    CAIRO_OPERATOR_DEST:= 6.
    CAIRO_OPERATOR_DEST_OVER:= 7.
    CAIRO_OPERATOR_DEST_IN:= 8.
    CAIRO_OPERATOR_DEST_OUT:= 9.
    CAIRO_OPERATOR_DEST_ATOP:= 10.

    CAIRO_OPERATOR_XOR:= 11.
    CAIRO_OPERATOR_ADD:= 12.
    CAIRO_OPERATOR_SATURATE:= 13.

    CAIRO_OPERATOR_MULTIPLY:= 14.
    CAIRO_OPERATOR_SCREEN:= 15.
    CAIRO_OPERATOR_OVERLAY:= 16.
    CAIRO_OPERATOR_DARKEN := 17.
    CAIRO_OPERATOR_LIGHTEN := 18.
    CAIRO_OPERATOR_COLOR_DODGE := 19.
    CAIRO_OPERATOR_COLOR_BURN := 20.
    CAIRO_OPERATOR_HARD_LIGHT := 21.
    CAIRO_OPERATOR_SOFT_LIGHT := 22.
    CAIRO_OPERATOR_DIFFERENCE := 23.
    CAIRO_OPERATOR_EXCLUSION := 24.
    CAIRO_OPERATOR_HSL_HUE := 25.
    CAIRO_OPERATOR_HSL_SATURATION := 26.
    CAIRO_OPERATOR_HSL_COLOR := 27.
    CAIRO_OPERATOR_HSL_LUMINOSITY := 28.
"} cairo_operator_t;"! !

!AthensCairoDefs classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/16/2011 11:24'!
initialize_cairo_status_t
"	typedef enum _cairo_status {"
    CAIRO_STATUS_SUCCESS := 0.

    CAIRO_STATUS_NO_MEMORY:=1.
    CAIRO_STATUS_INVALID_RESTORE:=2.
    CAIRO_STATUS_INVALID_POP_GROUP:=3.
    CAIRO_STATUS_NO_CURRENT_POINT:=4.
    CAIRO_STATUS_INVALID_MATRIX:=5.
    CAIRO_STATUS_INVALID_STATUS:=6.
    CAIRO_STATUS_NULL_POINTER:=7.
    CAIRO_STATUS_INVALID_STRING:=8.
    CAIRO_STATUS_INVALID_PATH_DATA:=9.
    CAIRO_STATUS_READ_ERROR:= 10.
    CAIRO_STATUS_WRITE_ERROR:=11.
    CAIRO_STATUS_SURFACE_FINISHED:=12.
    CAIRO_STATUS_SURFACE_TYPE_MISMATCH:=13.
    CAIRO_STATUS_PATTERN_TYPE_MISMATCH:=14.
    CAIRO_STATUS_INVALID_CONTENT:=15.
    CAIRO_STATUS_INVALID_FORMAT:=16.
    CAIRO_STATUS_INVALID_VISUAL:=17.
    CAIRO_STATUS_FILE_NOT_FOUND:=18.
    CAIRO_STATUS_INVALID_DASH:=19.
    CAIRO_STATUS_INVALID_DSC_COMMENT:=20.
    CAIRO_STATUS_INVALID_INDEX:=21.
    CAIRO_STATUS_CLIP_NOT_REPRESENTABLE:=22.
    CAIRO_STATUS_TEMP_FILE_ERROR:=23.
    CAIRO_STATUS_INVALID_STRIDE:=24.
    CAIRO_STATUS_FONT_TYPE_MISMATCH:=25.
    CAIRO_STATUS_USER_FONT_IMMUTABLE:=26.
    CAIRO_STATUS_USER_FONT_ERROR:=27.
    CAIRO_STATUS_NEGATIVE_COUNT:=28.
    CAIRO_STATUS_INVALID_CLUSTERS:=29.
    CAIRO_STATUS_INVALID_SLANT:=30.
    CAIRO_STATUS_INVALID_WEIGHT:=31.
    CAIRO_STATUS_INVALID_SIZE:=32.
    CAIRO_STATUS_USER_FONT_NOT_IMPLEMENTED:=33.
    CAIRO_STATUS_DEVICE_TYPE_MISMATCH:=34.
    CAIRO_STATUS_DEVICE_ERROR:=35.

    
! !

!AthensCairoDefs classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 14:13'!
initialize_types
	
	cairo_font_type_t :=  cairo_line_join_t := cairo_status_t := cairo_font_slant_t := cairo_font_weight_t := cairo_operator_t  := #int.
	

	cairo_surface_t := NBExternalAddress! !

!TextMorph methodsFor: '*Athens' stamp: 'IgorStasenko 11/10/2011 10:04'!
drawOnAthensCanvas: aCanvas

	"Draw the receiver on a canvas.
	Draw keyboard focus if appropriate."

	| fauxBounds |

	self setDefaultContentsIfNil.
	super drawOnAthensCanvas: aCanvas.  "Border and background if any"
	
	"nothing to draw?"
	(self startingIndex > text size)
		ifTrue: [ ^ self ].

	"Hack here:  The canvas expects bounds to carry the location of the text, but we also need to communicate clipping."
	fauxBounds := self bounds topLeft corner: self innerBounds bottomRight.
	
	self paragraph drawOnAthensCanvas: aCanvas bounds: fauxBounds.
	
	[ ^ self] value.
	self halt.
	aCanvas paragraph: self paragraph bounds: fauxBounds.
	! !

!DisplayTransform class methodsFor: '*Athens' stamp: 'cyrille.delaunay 5/17/2010 15:52'!
howToPassAsArgument
	^#passByClone:! !

!FreeTypeFont methodsFor: '*Athens' stamp: 'IgorStasenko 11/7/2011 14:15'!
getGlyphWidth: aCharacter 
	aCharacter asciiValue = 9 ifTrue: [ 
		^  (self linearWidthOf: Character space) * 8
		]. 
	^ (self linearWidthOf: aCharacter)! !

!FreeTypeFont methodsFor: '*Athens' stamp: 'IgorStasenko 10/28/2011 12:28'!
getPreciseAscent
	"we using face bouding box for getting ascent value, otherwise two different
	font sizes on same line won't align properly"
	
	^(self face bbox bottom * self pixelSize / self face unitsPerEm) asFloat.
! !

!FreeTypeFont methodsFor: '*Athens' stamp: 'IgorStasenko 11/7/2011 14:47'!
getPreciseDescent
	"we using face bouding box for getting ascent value, otherwise two different
	font sizes on same line won't align properly"
	
	^(self face descender * self pixelSize / self face unitsPerEm) asFloat negated.

! !

!FreeTypeFont methodsFor: '*Athens' stamp: 'IgorStasenko 10/28/2011 11:46'!
getPreciseHeight
	"get precise font ascent, can be floating value"
	
	^(self face height * self pixelSize / self face unitsPerEm) asFloat.
! !

!FreeTypeFont methodsFor: '*Athens' stamp: 'IgorStasenko 10/20/2011 05:12'!
glyphRendererOn: anAthensSurface

	^ anAthensSurface getFreetypeFontRendererFor: self
! !

!FreeTypeFont methodsFor: '*Athens' stamp: 'IgorStasenko 10/17/2011 16:52'!
renderGlyph: aCharacter on: anAthensCanvas 
	| form |

	FreeTypeSettings current 
		forceNonSubPixelDuring:[
	form := self 
		glyphOf: aCharacter 
				destDepth: 8
				colorValue: 1
				subpixelPosition: 0.
	].				
	anAthensCanvas drawImage: form.
	^ form width.! !

FT2GlyphSlot subclass: #SimpleTextGlyphInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Text'!

!SimpleTextGlyphInfo classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 7/13/2011 04:04'!
fromFace: anFT2Face
	^(self new)
		loadFrom: anFT2Face;
		yourself.! !

!SimpleTextGlyphInfo methodsFor: 'accessing' stamp: 'IgorStasenko 7/13/2011 04:05'!
face
	^ face! !

!SimpleTextGlyphInfo methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/20/2011 05:09'!
loadFrom: anFT2Face
	"Same as in superclass, but avoid converting coordinates to not waste CPU cycles"
	
	face := anFT2Face.
	self primLoadFrom: anFT2Face.
	format := ((Smalltalk isLittleEndian) ifTrue: [ format reversed ] ifFalse: [ format ]) asString.
! !

!GradientFillStyle methodsFor: '*Athens' stamp: 'IgorStasenko 4/21/2011 15:25'!
asAthensPaintOn: anAthensCanvas

	^ radial ifTrue: [
		anAthensCanvas surface
			createCircularGradient: colorRamp
			center: origin
			radius: direction y ]
	ifFalse: [
		anAthensCanvas surface
			createLinearGradient: colorRamp
			origin: origin
			corner: origin + direction ]
! !

!ImageFillStyle methodsFor: '*Athens' stamp: 'IgorStasenko 4/22/2011 11:14'!
asAthensPaintOn: anAthensCanvas
	
	^ (anAthensCanvas surface
		createImagePaint: form)
		origin: origin;
		direction: (form width@0)! !

!SolidFillStyle methodsFor: '*Athens' stamp: 'IgorStasenko 4/21/2011 15:01'!
asAthensPaintOn: anAthensCanvas 

	^ anAthensCanvas surface createSolidColorPaint: color! !

!FillStyle class methodsFor: '*Athens' stamp: 'cyrille.delaunay 5/17/2010 15:30'!
none
	^Color transparent
! !

!FillStyle class methodsFor: '*Athens' stamp: 'cyrille.delaunay 5/17/2010 15:30'!
solid
	^Color white
! !

!PasteUpMorph methodsFor: '*Athens' stamp: 'IgorStasenko 4/21/2011 14:33'!
drawOnAthensCanvas: aCanvas 
	"Draw in order:
	- background color
	- background sketch, if any
	- Update and draw the turtleTrails form. See the comment in updateTrailsForm.

	Later (in drawSubmorphsOn:) I will skip drawing the background sketch."

	"draw background fill"
	super drawOnAthensCanvas: aCanvas.

	backgroundMorph ifNotNil: [
		aCanvas clipBy: self clippingBounds
			during: [ aCanvas fullDrawMorph: backgroundMorph ]
	]				
! !

!LazyListMorph methodsFor: '*Athens' stamp: 'IgorStasenko 10/4/2011 16:49'!
athensDisplay: item atRow: row on: aCanvas 
	"Display the given item at the given row on the given
	canvas."
	
	| c drawBounds frame attrs useDefaultFont |
	drawBounds := self drawBoundsForRow: row.
	c := self colorForRow: row.
	aCanvas
		drawString: item asString
		in: drawBounds
		font: self font
		color: (self colorForRow: row)! !

!LazyListMorph methodsFor: '*Athens' stamp: 'IgorStasenko 10/4/2011 16:50'!
athensDrawSelectionOn: anAthensCanvas 
	
self value! !

!LazyListMorph methodsFor: '*Athens' stamp: 'IgorStasenko 12/21/2011 13:56'!
drawOnAthensCanvas: aCanvas


	aCanvas setPaint: Color green.
	aCanvas drawShape: self bounds.
	
	listItems size = 0
		ifTrue: [^ self].
		
	"self drawSelectionOn: aCanvas."
	1 to: listItems size do: [:row |
		(listSource itemSelectedAmongMultiple: row)
			ifTrue: [ self athensDrawBackgroundForSelectedRow: row on: aCanvas]
			ifFalse: [
				(listSource searchedElement = row)
					ifTrue: [ self athensDrawBackgroundForSearchedRow: row on: aCanvas]
					ifFalse: [
						(listSource backgroundColorFor: row)
							ifNotNil: [:col |
								self athensDrawBackgroundForRow: row on: aCanvas color: col ]]].
					
			selectedRow = row ifTrue: [ self athensDrawSelectionOn: aCanvas ].
			(listSource separatorAfterARow: row) ifTrue: [ self athensDrawSeparatorAfter: row on: aCanvas ].
			self
				athensDisplay: (self item: row)
				atRow: row
				on: aCanvas].
		
	listSource potentialDropRow > 0
		ifTrue: [self athensHighlightPotentialDropRow: listSource potentialDropRow on: aCanvas]! !

!Rectangle methodsFor: '*Athens' stamp: 'IgorStasenko 3/22/2011 22:04'!
asAthensPathOn: anAthensCanvas 
	^ anAthensCanvas createRectanglePath: self! !

!Rectangle methodsFor: '*Athens' stamp: 'IgorStasenko 5/2/2011 04:51'!
asClosedPolygon
	"answer a closed clock-wise oriented polygon, representing receiver"
	
	^ {
		origin.
		corner x @ origin y.
		corner.
		origin x @ corner y.
		origin.
	}! !

!Rectangle methodsFor: '*Athens' stamp: 'IgorStasenko 3/27/2011 21:03'!
asClosedPolygonTransformedBy: aTransform
	"answer a clock-wise oriented polygon, representing receiver,
	transformed by transform"
	| orig |
	^ {
		orig := aTransform transform: origin.
		aTransform transformX: corner x Y: origin y.
		aTransform transform: corner.
		aTransform transformX: origin x Y: corner y.
		orig
	}! !

!Rectangle methodsFor: '*Athens' stamp: 'IgorStasenko 3/27/2011 18:44'!
asPolygon
	"answer a clock-wise oriented polygon, representing receiver"
	
	^ {
		origin.
		corner x @ origin y.
		corner.
		origin x @ corner y.
	}! !

!Rectangle methodsFor: '*Athens' stamp: 'IgorStasenko 3/27/2011 18:43'!
asPolygonTransformedBy: aTransform
	"answer a clock-wise oriented polygon, representing receiver,
	transformed by transform"
	
	^ {
		aTransform transform: origin.
		aTransform transformX: corner x Y: origin y.
		aTransform transform: corner.
		aTransform transformX: origin x Y: corner y.
	}! !

!Rectangle methodsFor: '*Athens' stamp: 'IgorStasenko 3/23/2011 03:00'!
paintFillsUsing: aPaint on: anAthensCanvas 
	"This method is a part of rendering dispatch  Canvas->receiver->paint"
	
	^ aPaint fillRectangle: self on: anAthensCanvas! !

!TransformMorph methodsFor: '*Athens' stamp: 'IgorStasenko 10/4/2011 16:22'!
fullDrawOnAthensCanvas: anAthensCanvas 
	"Draw the full Morphic structure on the given Canvas"

	self visible ifFalse: [^ self].
	(anAthensCanvas isVisible: self fullBounds) ifFalse: [^self].
	(self hasProperty: #errorOnDraw) ifTrue: [^self "drawErrorOn: aCanvas" ].

	(anAthensCanvas isVisible: self bounds) ifTrue: [ anAthensCanvas draw: self ].
	
	submorphs isEmpty ifTrue: [^self].

	self clipSubmorphs ifTrue: [ | clip p1 p2 old |
		
		"transform clipping bounds "
		clip := self clippingBounds.
		p1 := anAthensCanvas pathTransform transform: clip origin.
		p2 := anAthensCanvas pathTransform transform: clip corner.
		clip := Rectangle origin:  p1 corner: p2.
		
		"transform coordinate space"
		old := anAthensCanvas pathTransform copy.
		anAthensCanvas pathTransform translateBy: self transform offset negated.
		
		anAthensCanvas 
			clipBy: clip 
			during: [ submorphs reverseDo: [:m | anAthensCanvas fullDrawMorph: m ] ].
			
		anAthensCanvas pathTransform: old.

	] 
	ifFalse: [
		submorphs reverseDo: [:m | anAthensCanvas fullDrawMorph: m ]
	]
! !

!Color methodsFor: '*Athens' stamp: 'IgorStasenko 6/11/2011 17:16'!
alpha8
	^ (self alpha * 255.0) truncated! !

!Color methodsFor: '*Athens' stamp: 'IgorStasenko 4/13/2011 17:47'!
asAthensPaintOn: anAthensCanvas
	^ anAthensCanvas surface createSolidColorPaint: self! !

!Color methodsFor: '*Athens' stamp: 'IgorStasenko 6/10/2011 18:13'!
blue8
" (0..1023 bitShift: -2) "
	^ self privateBlue bitShift: -2
! !

!Color methodsFor: '*Athens' stamp: 'IgorStasenko 6/10/2011 18:13'!
green8
" (0..1023 bitShift: -2) "
	^ self privateGreen bitShift: -2
! !

!Color methodsFor: '*Athens' stamp: 'IgorStasenko 6/10/2011 18:13'!
red8
" (0..1023 bitShift: -2) "
	^ self privateRed bitShift: -2
! !

!MultiNewParagraph methodsFor: '*Athens' stamp: 'IgorStasenko 9/19/2011 17:24'!
drawOnAthensCanvas: anAthensCanvas bounds: aRectangle 
	self shouldBeImplemented.! !

BalloonEngine subclass: #AthensBalloonEngine
	instanceVariableNames: 'currentFill'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Balloon'!

!AthensBalloonEngine commentStamp: 'IgorStasenko 3/29/2011 01:04' prior: 0!
- balloon engine using only first 4 variables of receiver instance:

 - work buffer
 - span
 - bitBlt (Bitblt object)
 - forms

!

!AthensBalloonEngine methodsFor: 'accessing' stamp: 'IgorStasenko 9/19/2011 16:15'!
clipRect: aRect

	clipRect := aRect truncated.
	! !

!AthensBalloonEngine methodsFor: 'drawing' stamp: 'IgorStasenko 4/21/2011 16:20'!
copyBits
	(bitBlt notNil and:[bitBlt destForm notNil]) ifTrue:[bitBlt destForm unhibernate].
	self copyLoopFastest.! !

!AthensBalloonEngine methodsFor: 'drawing' stamp: 'IgorStasenko 4/22/2011 13:56'!
drawImage: aForm transform: m 
	| orig dir normal tr corner rect |

	rect := aForm boundingBox.
	orig := 0@0. 
	dir := aForm width @ 0.
	normal := 0 @ aForm height.
	
	tr := edgeTransform.
	edgeTransform := m.

	self prepareForRendering.
	self registerFormFill: aForm
		origin: orig
		direction: dir
		normal: normal.
	self fillRectangle: rect.

	edgeTransform := tr.
! !

!AthensBalloonEngine methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 9/19/2011 16:37'!
fastReset

	workBuffer ifNil: [ ^ self reset ].

	workBuffer 
		at: (1+GWState) put: GEStateUnlocked;
		at: (1+GWObjUsed) put: 4;
		at: (1+GWNeedsFlush) put: 0;
		at: (1+GWCurrentZ) put: 0;
		at: (1+GWGETStart) put: 0";

		at: (1+GWGETUsed) put: 0;
		at: (1+GWAETStart) put: 0;
		at: (1+GWAETUsed) put: 0".
	
	self primSetEdgeTransform: edgeTransform.
	self primSetClipRect: clipRect.
	self primSetColorTransform: colorTransform.
	self primSetDepth: self primGetDepth + 1. 

	postFlushNeeded := false.
	forms := #().

"	
-	self magicNumberPut: GWMagicNumber.
- 	self wbSizePut: size.
+	self wbTopPut: size.
+	self statePut: GEStateUnlocked.
-	self objStartPut: GWHeaderSize.
+	self objUsedPut: 4.	
-	self objectTypeOf: 0 put: GEPrimitiveFill.
-	self objectLengthOf: 0 put: 4.
-	self objectIndexOf: 0 put: 0.

	self getStartPut: 0.
	self getUsedPut: 0.
	self aetStartPut: 0.
	self aetUsedPut: 0.
	self stopReasonPut: 0.

+	self needsFlushPut: 0.
-	self clipMinXPut: 0.
-	self clipMaxXPut: 0.
-	self clipMinYPut: 0.
-	self clipMaxYPut: 0.
+	self currentZPut: 0.
	self resetGraphicsEngineStats.
	self initEdgeTransform.
	self initColorTransform.
"! !

!AthensBalloonEngine methodsFor: 'drawing' stamp: 'IgorStasenko 4/1/2011 09:26'!
fillBezierShape: contours

	contours do:[ :points |
		self primAddBezierShape: points
			segments: (points size // 3)
			fill: currentFill
			lineWidth: 0
			lineFill: 0.
			
		"Note: To avoid premature flushing of the pipeline we need to reset the flush bit within the engine."
		self primFlushNeeded: false.
	].

	self copyBits.! !

!AthensBalloonEngine methodsFor: 'drawing' stamp: 'IgorStasenko 4/21/2011 15:04'!
fillRectangle: rect 

	currentFill = 0 ifTrue: [ ^ self ]. "no fill "
	self primAddRectFrom: rect origin 
			to: rect corner
			fillIndex: currentFill
			borderWidth: 0
			borderColor: 0.

	self copyBits.
	! !

!AthensBalloonEngine methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 4/13/2011 12:15'!
prepareForRendering
	self fastReset! !

!AthensBalloonEngine methodsFor: 'registering fills' stamp: 'IgorStasenko 4/1/2011 09:16'!
registerColorFill: aColor 

	currentFill := aColor scaledPixelValue32.
! !

!AthensBalloonEngine methodsFor: 'registering fills' stamp: 'IgorStasenko 4/22/2011 18:52'!
registerFormFill: form origin: orig direction: dir normal: norm

	forms := forms copyWith: form.
	form unhibernate.
	currentFill := self primAddBitmapFill: form
			colormap: (form colormapIfNeededForDepth: 32)
			tile: true "shall we always tile? "
			from: orig
			along: dir
			normal: norm
			xIndex: forms size.
			
! !

!AthensBalloonEngine methodsFor: 'paints' stamp: 'IgorStasenko 4/1/2011 16:01'!
registerLinearGradient: colorRamp origin: origin corner: corner 
	| pixelRamp direction normal |
	
	pixelRamp := GradientFillStyle pixelRampCache at: colorRamp.
	direction := corner - origin.
	normal := direction y negated @ direction x.
	
	currentFill := 
		self primAddGradientFill: pixelRamp
			from: origin
			along: direction
			normal:  normal
			radial:  false.! !

!AthensBalloonEngine methodsFor: 'paints' stamp: 'IgorStasenko 4/14/2011 17:15'!
registerRadialGradient: colorRamp center: aCenter direction: dir normal: n 
	| pixelRamp |
	
	pixelRamp := GradientFillStyle pixelRampCache at: colorRamp.
	
	currentFill := 
		self primAddGradientFill: pixelRamp
			from: aCenter
			along: dir
			normal:  n
			radial:  true.! !

!AthensBalloonEngine methodsFor: 'paints' stamp: 'IgorStasenko 4/14/2011 16:26'!
registerRadialGradient: colorRamp center: aCenter radius: r 
	| pixelRamp |
	
	pixelRamp := GradientFillStyle pixelRampCache at: colorRamp.
	
	currentFill := 
		self primAddGradientFill: pixelRamp
			from: aCenter
			along: (aCenter x + r @ aCenter y)
			normal:  (aCenter x  @ aCenter y - r)
			radial:  true.! !

!AthensBalloonEngine methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 4/22/2011 14:00'!
reset
	workBuffer ifNil:[workBuffer := self class allocateOrRecycleBuffer: 10000].
	self primInitializeBuffer: workBuffer.
	self primSetAALevel: 4.
	self primSetOffset: 0@0.
	self primSetClipRect: clipRect.
	self primSetEdgeTransform: edgeTransform.
	self primSetColorTransform: colorTransform.
	forms := #().! !

!AthensBalloonEngine methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 4/1/2011 09:03'!
setFill: aFill
	currentFill := aFill! !

!AthensBalloonEngine methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 9/14/2011 15:12'!
strokeBezierShape: contours width: aWidth

	contours do:[ :points |
		self primAddBezierShape: points
			segments: (points size // 3)
			fill: 0
			lineWidth: aWidth
			lineFill: currentFill.
			
		"Note: To avoid premature flushing of the pipeline we need to reset the flush bit within the engine."
		self primFlushNeeded: false.
	].

	self copyBits. 
! !

!AthensBalloonEngine methodsFor: 'drawing' stamp: 'IgorStasenko 5/2/2011 04:36'!
strokeRectangle: rect borderWidth: width

	currentFill = 0 ifTrue: [ ^ self ]. "no fill "
	self primAddRectFrom: rect origin 
			to: rect corner
			fillIndex: 0
			borderWidth: width
			borderColor: currentFill.

	self copyBits.
	! !

!AthensBalloonEngine methodsFor: 'drawing' stamp: 'IgorStasenko 9/19/2011 15:38'!
strokeRectangle: rect width: aWidth

	currentFill = 0 ifTrue: [ ^ self ]. "no fill "
	self primAddRectFrom: rect origin 
			to: rect corner
			fillIndex: 0
			borderWidth: aWidth asInteger
			borderColor: currentFill.

	self copyBits.
	! !

TextMorphForEditView subclass: #AthensTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Text'!

!AthensTextMorph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 12:42'!
contents: stringOrText wrappedTo: width
	"Accept new text contents.  Lay it out, wrapping to width.
	Then fit my height to the result."
	wrapFlag := true.
	super extent: width truncated@self height.
	self newContents: stringOrText! !

!AthensTextMorph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 12:23'!
createParagraph
	| newParagraph |
	self setDefaultContentsIfNil.

	"...Code here to recreate the paragraph..."
	newParagraph  := AthensParagraph new.
	
	newParagraph
		compose: text
		style: textStyle copy
		in: self container.
		
		
	wrapFlag ifFalse:
		["Was given huge container at first... now adjust"
		newParagraph adjustRightX].
	
	newParagraph focused: (self currentHand keyboardFocus == self).
	
	paragraph := newParagraph.
	self fit.

	^ paragraph! !

!AthensTextMorph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 12:18'!
paragraph
	^ paragraph ifNil: [ paragraph := self createParagraph ].
! !

!AthensTextMorph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 13:02'!
selectionColor: aColor
	selectionColor := aColor.
	! !

PluggableTextMorph subclass: #AthensPluggableTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Text'!

!AthensPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 12:01'!
textMorphClass
	^ AthensTextMorph! !

TextAttribute subclass: #AthensTextBackground
	instanceVariableNames: 'color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Text'!

!AthensTextBackground methodsFor: 'accessing' stamp: 'IgorStasenko 10/28/2011 14:42'!
color

	^ color! !

!AthensTextBackground methodsFor: 'accessing' stamp: 'IgorStasenko 10/28/2011 14:42'!
color: anObject

	color := anObject! !

!AthensTextBackground methodsFor: 'scanning' stamp: 'IgorStasenko 10/28/2011 14:31'!
dominates: other
	^ other class == self class! !

!AthensTextBackground methodsFor: 'scanning' stamp: 'IgorStasenko 10/28/2011 14:31'!
emphasizeScanner: scanner
	"Set the emphasis for text display"
	scanner textBackground: color! !

!AthensTextBackground methodsFor: 'comparing' stamp: 'IgorStasenko 10/28/2011 14:31'!
hash
	^ color hash! !

!AthensTextBackground methodsFor: 'printing' stamp: 'IgorStasenko 10/28/2011 14:32'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' code: '; print: color! !

!MatrixTransform2x3 class methodsFor: '*Athens' stamp: 'cyrille.delaunay 5/17/2010 15:53'!
fromRemoteCanvasEncoding: encoded
	"CDisplayTransform fromRemoteCanvasEncoding:  'Matrix,1065353216,0,1137541120,0,1065353216,1131610112,'"
	| nums transform encodedNums |
	"split the numbers up"
	encodedNums := encoded findTokens: ','.
	"remove the initial 'Matrix' specification"
	encodedNums := encodedNums asOrderedCollection.
	encodedNums removeFirst.
	"parse the numbers"
	nums := encodedNums collect: [ :enum |
		Integer readFromString: enum ].
	"create an instance"
	transform := self new.
	"plug in the numbers"
	nums doWithIndex: [ :num :i |
		transform basicAt: i put: num ].
	^transform! !

!MatrixTransform2x3 class methodsFor: '*Athens' stamp: 'cyrille.delaunay 5/17/2010 15:53'!
initialize
	"register myself with DataStream"

	DataStream initialize! !

!MatrixTransform2x3 class methodsFor: '*Athens' stamp: 'cyrille.delaunay 5/17/2010 15:54'!
localRect: localBounds toGlobal: globalBounds
	^self transformFromLocal: localBounds toGlobal: globalBounds! !

!LogicalFont methodsFor: '*Athens' stamp: 'IgorStasenko 10/28/2011 12:42'!
getGlyphWidth: aCharacter 
	^ self realFont getGlyphWidth: aCharacter 
! !

!LogicalFont methodsFor: '*Athens' stamp: 'IgorStasenko 10/28/2011 11:33'!
getPreciseAscent
	^ self realFont getPreciseAscent! !

!LogicalFont methodsFor: '*Athens' stamp: 'IgorStasenko 11/7/2011 14:37'!
getPreciseDescent
	^ self realFont getPreciseDescent! !

!LogicalFont methodsFor: '*Athens' stamp: 'IgorStasenko 10/28/2011 12:41'!
getPreciseHeight
	^ self realFont getPreciseHeight! !

!LogicalFont methodsFor: '*Athens' stamp: 'IgorStasenko 10/20/2011 05:11'!
glyphRendererOn: anAthensSurface 
	^ self realFont glyphRendererOn: anAthensSurface 
! !

!LogicalFont methodsFor: '*Athens' stamp: 'IgorStasenko 10/17/2011 15:43'!
renderGlyph: aCharacter on: anAthensCanvas 
	^ self realFont renderGlyph: aCharacter on: anAthensCanvas 
! !

!TTFontDescription classSide methodsFor: '*Athens' stamp: 'cyrille.delaunay 5/20/2010 14:59'!
addFromAllTTFilesIn: pathString

	"self addFromAllTTFilesIn: FileDirectory default fullName, '/Fonts/DejaVu'"
	|directory|
	[directory := FileDirectory on: pathString] on: Error do: [Error signal: 'invalid directory path'].
	directory fileNames do: [:fileString |
		(fileString endsWith: '.ttf')
			ifTrue: [ 
				Descriptions detect: [:aTTFontDescription | 
					aTTFontDescription postscriptName = (fileString copyFrom: 1 to: (fileString size-4))] 
				ifNone: [
					(pathString endsWith: '/')
					ifTrue: [self addFromTTFile: pathString,fileString]
					ifFalse: [self addFromTTFile: pathString,'/',fileString].
							]
				].
		]
	! !

!TTFontDescription classSide methodsFor: '*Athens' stamp: 'cyrille.delaunay 5/20/2010 16:02'!
family: familyString style: styleString

	^ Descriptions detect: [:aTTFontDescription |
		aTTFontDescription familyName = familyString 
			and: [aTTFontDescription subfamilyName = styleString ]
		] ifNone: [Default]! !

!TTFontDescription classSide methodsFor: '*Athens' stamp: 'cyrille.delaunay 5/20/2010 15:32'!
initializeWithDejaVuFonts

	"self initializeWithDejaVuFonts"
	Default ifNil: [
		self addFromAllTTFilesIn: FileDirectory default fullName, '/Fonts/DejaVu'.
		Default := Descriptions detect: [ :aTTFontDescription | 
			aTTFontDescription familyName = 'DejaVu Sans' and: [aTTFontDescription subfamilyName = 'Book'] 
		] ifNone: [Descriptions anyOne].
		]

! !

!TTFontDescription methodsFor: '*Athens' stamp: 'bf 7/20/2006 11:59'!
kerningLeft: leftChar right: rightChar
	| leftIndex rightIndex key |
	leftIndex := (self at: leftChar) glyphIndex.
	rightIndex := (self at: rightChar) glyphIndex.
	key := TTKernPair maskFor: leftIndex with: rightIndex.
	^(kernPairs
		findBinary: [:each | key - each mask]
		ifNone: [^0])
			value! !

Object subclass: #AthensBitmap
	instanceVariableNames: 'source format width height bits start stride'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Bitmaps'!

!AthensBitmap methodsFor: 'accessing' stamp: 'IgorStasenko 6/10/2011 17:37'!
bits

	^ bits! !

!AthensBitmap methodsFor: 'accessing' stamp: 'IgorStasenko 6/10/2011 17:37'!
bits: anObject

	bits := anObject! !

!AthensBitmap methodsFor: 'accessing pixel data' stamp: 'IgorStasenko 6/10/2011 17:59'!
colorAt: aPoint
	^ format readColorFrom: self x: aPoint x  y: aPoint y! !

!AthensBitmap methodsFor: 'accessing pixel data' stamp: 'IgorStasenko 6/10/2011 17:57'!
colorAt: aPoint put: aColor
	^ format writeColor: aColor to: bits x: aPoint x  y: aPoint y  stride: stride offset: start! !

!AthensBitmap methodsFor: 'accessing' stamp: 'IgorStasenko 6/10/2011 17:37'!
format

	^ format! !

!AthensBitmap methodsFor: 'accessing' stamp: 'IgorStasenko 6/10/2011 17:37'!
format: anObject

	format := anObject! !

!AthensBitmap methodsFor: 'accessing' stamp: 'IgorStasenko 6/10/2011 17:37'!
height

	^ height! !

!AthensBitmap methodsFor: 'accessing' stamp: 'IgorStasenko 6/10/2011 17:37'!
height: anObject

	height := anObject! !

!AthensBitmap methodsFor: 'accessing' stamp: 'IgorStasenko 6/10/2011 17:37'!
source

	^ source! !

!AthensBitmap methodsFor: 'accessing' stamp: 'IgorStasenko 6/10/2011 17:37'!
source: anObject

	source := anObject! !

!AthensBitmap methodsFor: 'accessing' stamp: 'IgorStasenko 6/10/2011 17:37'!
start

	^ start! !

!AthensBitmap methodsFor: 'accessing' stamp: 'IgorStasenko 6/10/2011 17:37'!
start: anObject

	start := anObject! !

!AthensBitmap methodsFor: 'accessing' stamp: 'IgorStasenko 6/10/2011 17:37'!
stride

	^ stride! !

!AthensBitmap methodsFor: 'accessing' stamp: 'IgorStasenko 6/10/2011 17:37'!
stride: anObject

	stride := anObject! !

!AthensBitmap methodsFor: 'accessing' stamp: 'IgorStasenko 6/10/2011 17:37'!
width

	^ width! !

!AthensBitmap methodsFor: 'accessing' stamp: 'IgorStasenko 6/10/2011 17:37'!
width: anObject

	width := anObject! !

Object subclass: #AthensBitmapFormat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Bitmaps'!

AthensBitmapFormat subclass: #AthensRGBFormat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Bitmaps'!

AthensRGBFormat subclass: #AthensRGB24Format
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Bitmaps'!

!AthensRGB24Format commentStamp: 'IgorStasenko 6/10/2011 17:48' prior: 0!
Each pixel has 3 8-bit components: red, green, blue!

!AthensRGB24Format methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 6/10/2011 17:59'!
readColorFrom: aBitmap x: x y: y 

	| offset bits |
	offset := (y* aBitmap stride) + (x*3) + aBitmap start.
	bits := aBitmap bits.

	^ Color
		r: (bits at: offset)
		g: (bits at: offset + 1)
		b: (bits at: offset + 2)
		range: 255! !

!AthensRGB24Format methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 6/10/2011 18:15'!
writeColor: aColor to: aBitmap x: x y: y 

	| offset |
	offset := (y*aBitmap stride) + (x*3) + aBitmap start.
	aBitmap bits
		at: offset put: aColor red8;
		at: offset+1 put: aColor green8;
		at: offset+2 put: aColor blue8
! !

AthensRGBFormat subclass: #AthensRGB32Format
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Bitmaps'!

!AthensRGB32Format methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 6/11/2011 17:14'!
readColorFrom: aBitmap x: x y: y 

	| offset bits |
	offset := (y* aBitmap stride) + (x*4) + aBitmap start.
	bits := aBitmap bits.

	^ Color
		r: (bits at: offset)
		g: (bits at: offset + 1)
		b: (bits at: offset + 2)
		range: 255! !

!AthensRGB32Format methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 6/11/2011 17:14'!
writeColor: aColor to: aBitmap x: x y: y 

	| offset |
	offset := (y*aBitmap stride) + (x*4) + aBitmap start.
	aBitmap bits
		at: offset put: aColor red8;
		at: offset+1 put: aColor green8;
		at: offset+2 put: aColor blue8
! !

AthensRGBFormat subclass: #AthensRGBA32Format
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Bitmaps'!

!AthensRGBA32Format methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 6/11/2011 17:18'!
readColorFrom: aBitmap x: x y: y 

	| offset bits |
	offset := (y* aBitmap stride) + (x*4) + aBitmap start.
	bits := aBitmap bits.

	^ (Color
		r: (bits at: offset)
		g: (bits at: offset + 1)
		b: (bits at: offset + 2)
		range: 255)
		alpha: (bits at: offset +3 ) / 255! !

!AthensRGBA32Format methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 6/11/2011 17:15'!
writeColor: aColor to: aBitmap x: x y: y 

	| offset |
	offset := (y*aBitmap stride) + (x*4) + aBitmap start.
	aBitmap bits
		at: offset put: aColor red8;
		at: offset+1 put: aColor green8;
		at: offset+2 put: aColor blue8;
		at: offset+3 put: aColor alpha8
! !

Object subclass: #AthensCanvas
	instanceVariableNames: 'paint surface'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Core'!

AthensCanvas subclass: #AthensCairoCanvas
	instanceVariableNames: 'handle pathTransform'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Cairo'!

!AthensCairoCanvas commentStamp: 'IgorStasenko 12/20/2011 15:58' prior: 0!
my instances representing a low-level cairo context and mapped to cairo_t * C type!

!AthensCairoCanvas classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 15:45'!
asNBExternalType: gen
	"use handle ivar to hold my instance (cairo_t)"
	^ NBExternalObjectType objectClass: self! !

!AthensCairoCanvas classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 16:12'!
nbLibraryNameOrHandle
	^ AthensCairoSurface nbLibraryNameOrHandle! !

!AthensCairoCanvas classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 16:14'!
on: cairoSurface

	^ (self primCreate: cairoSurface) surface: cairoSurface! !

!AthensCairoCanvas classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 16:14'!
primCreate: cairoSurface

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #( 
		AthensCairoCanvas cairo_create (AthensCairoSurface cairoSurface) )! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'IgorStasenko 12/20/2011 15:56'!
destroy

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #( 	void cairo_destroy (self) )! !

!AthensCairoCanvas methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/21/2011 12:33'!
emitPathCommandsFor: anAthensCairoPath 

	| segment |
	segment := anAthensCairoPath pathStart.
	
	[ segment notNil ] whileTrue: [
		segment visitWith: self.
		segment := segment next.
	]
! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'IgorStasenko 12/20/2011 16:10'!
fill
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(void cairo_fill (self))
! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'IgorStasenko 12/20/2011 18:50'!
lineToX: x Y: y

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(void cairo_line_to (self,
		 double x, double y ) )
! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'IgorStasenko 12/20/2011 18:48'!
moveToX: x Y: y 
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(void cairo_move_to (self,
		 double x, double y ) )
! !

!AthensCairoCanvas methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 16:11'!
nbLibraryNameOrHandle
	^ self class nbLibraryNameOrHandle
! !

!AthensCairoCanvas methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 16:48'!
pathTransform
	^ pathTransform! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'IgorStasenko 12/20/2011 16:05'!
rectangleX: x y: y width: aWidth height: aHeight
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(void cairo_rectangle (self,
		 double x, double y,
		 double aWidth, double aHeight) )
! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'IgorStasenko 12/20/2011 16:17'!
setSourceR: red g: green b: blue a: alpha

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( 
		void cairo_set_source_rgba ( self ,
			double red,
			double green,
			double blue,
			double alpha) )! !

!AthensCairoCanvas methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 16:49'!
surface: aCairoSurface
	
	"initialize for given surface"
	surface := aCairoSurface.
	
	pathTransform := AthensCairoTransform for: self! !

!AthensCairoCanvas methodsFor: 'path segments visitor' stamp: 'IgorStasenko 12/20/2011 18:49'!
visitLineSegment: line

	^ self lineToX: line endPoint x Y: line endPoint y! !

!AthensCairoCanvas methodsFor: 'path segments visitor' stamp: 'IgorStasenko 12/20/2011 18:46'!
visitMoveSegment: mov 
	^ self moveToX: mov endPoint x Y: mov endPoint y! !

!AthensCanvas classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/21/2011 00:19'!
new
	"use #on: instead"
	self shouldNotImplement! !

!AthensCanvas classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/21/2011 00:17'!
on: aSurface
	^ self basicNew initializeWithSurface: aSurface! !

!AthensCanvas methodsFor: 'masking' stamp: 'IgorStasenko 3/27/2011 18:31'!
clearMask: aShape
	"set mask pixels to 0 for all pixels covered by shape, aShape"
	^ aShape paintFillsUsing: surface clearMaskPaint on: self
! !

!AthensCanvas methodsFor: 'clipping' stamp: 'IgorStasenko 4/21/2011 14:47'!
clipBy: aRectangle during: aBlock
	
	" Set a clipping rectangle during drawing operations performed in a block.
	Note that clipping rectangle are intetersected with currently active clipping
	rectangle "
	
	 ^surface clipBy: aRectangle during: aBlock! !

!AthensCanvas methodsFor: 'paths' stamp: 'IgorStasenko 3/26/2011 19:31'!
createPath: aBlock

	| builder |
	builder := AthensPathBuilder new.
	aBlock value: builder.
	
	^ surface createPath: builder! !

!AthensCanvas methodsFor: 'paths' stamp: 'IgorStasenko 3/22/2011 22:04'!
createRectanglePath: aRectangle 
	^ surface createRectanglePath: aRectangle 
! !

!AthensCanvas methodsFor: 'masking' stamp: 'IgorStasenko 3/27/2011 18:06'!
disableMask
	^ surface disableMask! !

!AthensCanvas methodsFor: 'drawing' stamp: 'IgorStasenko 3/20/2011 23:51'!
draw: anObject

	^ anObject drawOnAthensCanvas: self! !

!AthensCanvas methodsFor: 'drawing' stamp: 'IgorStasenko 3/20/2011 23:50'!
draw: aShape cache: aBoolean
	"Main entry point.
	
	Draw given shape using currently selected paint"
	
	| cached driver |
	
	driver := self driver.
	
	aBoolean ifTrue: [
		"If shape already in cache, just draw it.
		If not, then put it into cache and draw it "
		
			cached := driver cache: aShape.
			
		driver renderPath: cached ]
	ifFalse: [
		
		driver render
		].
	(self driver cachedPathFor: aShape)! !

!AthensCanvas methodsFor: 'drawing' stamp: 'IgorStasenko 4/21/2011 16:26'!
drawImage: aForm

	^ surface drawImage: aForm! !

!AthensCanvas methodsFor: 'drawing' stamp: 'IgorStasenko 9/14/2011 15:36'!
drawShape: anObject
	"Fill the shape (anObject) using currently selected paint
	an object should implement double-dispatch to currently selected paint"
	
	^ anObject paintFillsUsing: paint on: self

! !

!AthensCanvas methodsFor: 'morphic' stamp: 'IgorStasenko 11/21/2011 16:24'!
drawString: aString in: aRectangle font: aFont color: aColor 
	
	| renderer |
	renderer := aFont glyphRendererOn:self surface.
	
	renderer 
		setColor: aColor;
		setPosition: aRectangle origin;
		renderGlyphsIn: aString from: 1 to: aString size
! !

!AthensCanvas methodsFor: 'masking' stamp: 'IgorStasenko 3/27/2011 18:06'!
enableMask
	^ surface enableMask! !

!AthensCanvas methodsFor: 'transformation matrices' stamp: 'IgorStasenko 4/1/2011 15:34'!
fillTransform
	^ surface fillTransform
! !

!AthensCanvas methodsFor: 'morphic' stamp: 'IgorStasenko 4/21/2011 14:27'!
fullDrawMorph: aMorph

"Hook method for potential other canvases. In the core, this method looks supefluous but PostscriptCanvases and other canvases can specialized it for Morph rendering. Therefore it should not be merged with fullDraw:."

	aMorph fullDrawOnAthensCanvas: self! !

!AthensCanvas methodsFor: 'transformation matrices' stamp: 'IgorStasenko 3/26/2011 00:37'!
imageTransform
	^ surface imageTransform
! !

!AthensCanvas methodsFor: 'transformation matrices' stamp: 'IgorStasenko 9/19/2011 16:10'!
imageTransform: anObject
	"set image transformation"
	 ^ surface imageTransform: anObject
! !

!AthensCanvas methodsFor: 'initialization' stamp: 'IgorStasenko 3/22/2011 11:13'!
initializeWithSurface: anAthensSurface	
	surface := anAthensSurface! !

!AthensCanvas methodsFor: 'clipping' stamp: 'IgorStasenko 4/21/2011 14:40'!
isVisible: aRectangle 
	"check if rectangle are not fully clipped by current clipping coordinates"
	
	^ true! !

!AthensCanvas methodsFor: 'transformation matrices' stamp: 'IgorStasenko 3/26/2011 00:38'!
paintTransform
	^ surface paintTransform
! !

!AthensCanvas methodsFor: 'transformation matrices' stamp: 'IgorStasenko 3/26/2011 02:16'!
paintTransform: anObject
	surface paintTransform: anObject
! !

!AthensCanvas methodsFor: 'morphic' stamp: 'IgorStasenko 4/22/2011 17:37'!
paragraph: aMultiNewParagraph bounds: aRectangle 
	self shouldBeImplemented.! !

!AthensCanvas methodsFor: 'transformation matrices' stamp: 'IgorStasenko 3/26/2011 00:37'!
pathTransform
	^ surface pathTransform
! !

!AthensCanvas methodsFor: 'transformation matrices' stamp: 'IgorStasenko 3/26/2011 02:16'!
pathTransform: anObject
	surface pathTransform: anObject
! !

!AthensCanvas methodsFor: 'masking' stamp: 'IgorStasenko 3/27/2011 18:35'!
setMask: aShape
	"set mask pixels to 1 for all pixels covered by shape, aShape"

	^ aShape paintFillsUsing: surface setMaskPaint on: self
! !

!AthensCanvas methodsFor: 'paint' stamp: 'IgorStasenko 9/14/2011 14:38'!
setPaint: aPaint
	^ paint := aPaint asAthensPaintOn: self! !

!AthensCanvas methodsFor: 'paint' stamp: 'IgorStasenko 9/14/2011 14:38'!
setStrokePaint: aPaint
	^ paint := (aPaint asAthensPaintOn: self) asStrokePaint! !

!AthensCanvas methodsFor: 'transformation matrices' stamp: 'IgorStasenko 3/26/2011 00:38'!
strokeTransform
	^ surface strokeTransform
! !

!AthensCanvas methodsFor: 'transformation matrices' stamp: 'IgorStasenko 3/26/2011 02:16'!
strokeTransform: anObject
	surface strokeTransform: anObject
! !

!AthensCanvas methodsFor: 'accessing' stamp: 'IgorStasenko 3/22/2011 22:39'!
surface
	^ surface! !

Object subclass: #AthensColorComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Bitmaps'!

Object subclass: #AthensPaint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Core'!

!AthensPaint commentStamp: 'IgorStasenko 3/20/2011 23:55' prior: 0!
I am a base class, which defines a paint style.
A paint should implement two methods:

 - fillPath: aPath on: aCanvas
 - strokePath: aPath on: aCanvas!

AthensPaint subclass: #AthensBalloonImagePaint
	instanceVariableNames: 'form origin direction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Balloon'!

!AthensBalloonImagePaint methodsFor: 'accessing' stamp: 'IgorStasenko 4/21/2011 15:45'!
direction

	^ direction! !

!AthensBalloonImagePaint methodsFor: 'accessing' stamp: 'IgorStasenko 4/21/2011 15:45'!
direction: anObject

	direction := anObject! !

!AthensBalloonImagePaint methodsFor: 'rendering' stamp: 'IgorStasenko 4/22/2011 11:19'!
fillPath: aPath on: anAthensCanvas

	anAthensCanvas surface engine
		prepareForRendering;
		registerFormFill: form origin: origin direction: direction normal: self normal;
		fillBezierShape: aPath contoursForFilling! !

!AthensBalloonImagePaint methodsFor: 'rendering' stamp: 'IgorStasenko 4/22/2011 11:18'!
fillRectangle: aRect on: anAthensCanvas
	"This is a terminal method in rendering dispatch scheme
	canvas->shape->paint. See AthensCanvas>>fillShape: "

	anAthensCanvas surface engine reset
		prepareForRendering;
		registerFormFill: form origin: origin direction: direction normal: self normal;
		fillRectangle: aRect
! !

!AthensBalloonImagePaint methodsFor: 'accessing' stamp: 'IgorStasenko 4/21/2011 15:30'!
form

	^ form! !

!AthensBalloonImagePaint methodsFor: 'accessing' stamp: 'IgorStasenko 4/21/2011 15:49'!
form: anObject

	form := anObject.
	origin := 0@0.
	direction := form extent x @0.! !

!AthensBalloonImagePaint methodsFor: 'accessing' stamp: 'IgorStasenko 4/21/2011 15:47'!
normal
	^ ((direction y negated @ direction x) *  form height / form width ) rounded! !

!AthensBalloonImagePaint methodsFor: 'accessing' stamp: 'IgorStasenko 4/21/2011 15:45'!
origin

	^ origin! !

!AthensBalloonImagePaint methodsFor: 'accessing' stamp: 'IgorStasenko 4/21/2011 15:45'!
origin: anObject

	origin := anObject! !

AthensPaint subclass: #AthensBalloonMaskPaint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Balloon'!

!AthensBalloonMaskPaint methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/27/2011 18:45'!
fillRectangle: aRect on: canvas
	"This is a terminal method in rendering dispatch scheme
	canvas->shape->paint. See AthensCanvas>>fillShape: "
	
	| transformed transform surf |
	
	transform := canvas pathTransform.
	transformed := aRect asPolygonTransformedBy: transform.
		
	canvas surface balloonCanvas
		drawPolygon: transformed
		fillStyle: Color black
		
! !

AthensPaint subclass: #AthensBalloonPaint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Balloon'!

AthensBalloonPaint subclass: #AthensBalloonGradientPaint
	instanceVariableNames: 'colorRamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Balloon'!

!AthensBalloonGradientPaint methodsFor: 'accessing' stamp: 'IgorStasenko 4/14/2011 16:27'!
colorRamp

	^ colorRamp! !

!AthensBalloonGradientPaint methodsFor: 'accessing' stamp: 'IgorStasenko 4/14/2011 16:27'!
colorRamp: anObject

	colorRamp := anObject! !

!AthensBalloonGradientPaint methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 9/19/2011 15:34'!
strokeRect: aRectangle on: anAthensCanvas stroke: anAthensBalloonStrokePaint 
	self shouldBeImplemented.! !

AthensBalloonGradientPaint subclass: #AthensBalloonLinearGradient
	instanceVariableNames: 'origin corner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Balloon'!

!AthensBalloonLinearGradient methodsFor: 'accessing' stamp: 'IgorStasenko 4/1/2011 10:47'!
corner

	^ corner! !

!AthensBalloonLinearGradient methodsFor: 'accessing' stamp: 'IgorStasenko 4/1/2011 10:47'!
corner: anObject

	corner := anObject! !

!AthensBalloonLinearGradient methodsFor: 'rendering' stamp: 'IgorStasenko 4/1/2011 15:33'!
fillPath: aPath on: anAthensCanvas
	| torigin tcorner |

	"A gradient fill coordinates are first transformed by 
	fillTransform matrix,
	then
	by pathTransform matrix"
		
	torigin := anAthensCanvas fillTransform transform: origin.
	tcorner :=  anAthensCanvas fillTransform transform: corner.

	^ anAthensCanvas surface engine
		prepareForRendering;
		registerLinearGradient: colorRamp origin: torigin corner: tcorner;
		fillBezierShape: aPath contoursForFilling! !

!AthensBalloonLinearGradient methodsFor: 'rendering' stamp: 'IgorStasenko 4/1/2011 15:40'!
fillRectangle: aRect on: anAthensCanvas
	"This is a terminal method in rendering dispatch scheme
	canvas->shape->paint. See AthensCanvas>>fillShape: "
	
	| torigin tcorner |

	"A gradient fill coordinates are first transformed by 
	fillTransform matrix,
	then
	by pathTransform matrix"
		
	torigin := anAthensCanvas fillTransform transform: origin.
	tcorner :=  anAthensCanvas fillTransform transform: corner.

	^ anAthensCanvas surface engine
		prepareForRendering;
		registerLinearGradient: colorRamp origin: torigin corner: tcorner;
		fillRectangle: aRect! !

!AthensBalloonLinearGradient methodsFor: 'accessing' stamp: 'IgorStasenko 4/1/2011 10:47'!
origin

	^ origin! !

!AthensBalloonLinearGradient methodsFor: 'accessing' stamp: 'IgorStasenko 4/1/2011 10:47'!
origin: anObject

	origin := anObject! !

!AthensBalloonLinearGradient methodsFor: 'rendering' stamp: 'IgorStasenko 9/19/2011 15:37'!
strokeRect: rect on: canvas stroke: strokePaint

	| torigin tcorner |

	"A gradient fill coordinates are first transformed by 
	fillTransform matrix,
	then
	by pathTransform matrix"
		
	torigin := canvas fillTransform transform: origin.
	tcorner :=  canvas fillTransform transform: corner.

	^ canvas surface engine
		prepareForRendering;
		registerLinearGradient: colorRamp origin: torigin corner: tcorner;
		strokeRectangle: rect width: strokePaint width! !

AthensBalloonGradientPaint subclass: #AthensBalloonRadialGradient
	instanceVariableNames: 'center radius'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Balloon'!

!AthensBalloonRadialGradient methodsFor: 'accessing' stamp: 'IgorStasenko 4/14/2011 16:27'!
center

	^ center! !

!AthensBalloonRadialGradient methodsFor: 'accessing' stamp: 'IgorStasenko 4/14/2011 16:27'!
center: anObject

	center := anObject! !

!AthensBalloonRadialGradient methodsFor: 'rendering' stamp: 'IgorStasenko 4/14/2011 17:10'!
fillPath: aPath on: anAthensCanvas
	"This is a terminal method in rendering dispatch scheme
	canvas->shape->paint. See AthensCanvas>>fillShape: "
	
	| c |

	c := anAthensCanvas fillTransform transform: center.

	^ anAthensCanvas surface engine
		prepareForRendering;
		registerRadialGradient: colorRamp center: c radius: radius;
		fillBezierShape: aPath contoursForFilling
! !

!AthensBalloonRadialGradient methodsFor: 'rendering' stamp: 'IgorStasenko 4/14/2011 17:24'!
fillRectangle: aRect on: anAthensCanvas
	"This is a terminal method in rendering dispatch scheme
	canvas->shape->paint. See AthensCanvas>>fillShape: "
	
	| c dir n |

	c := anAthensCanvas fillTransform transform: center.
	dir :=  (radius@0).
	n := (0@radius).
"	anAthensCanvas fillTransform transform: (radius@0).
	n := anAthensCanvas fillTransform transform: (0@ (0-radius)).
"
	
	^ anAthensCanvas surface engine
		prepareForRendering;
		registerRadialGradient: colorRamp center: c direction: dir normal: n;
		fillRectangle: aRect! !

!AthensBalloonRadialGradient methodsFor: 'accessing' stamp: 'IgorStasenko 4/14/2011 16:27'!
radius

	^ radius! !

!AthensBalloonRadialGradient methodsFor: 'accessing' stamp: 'IgorStasenko 4/14/2011 16:27'!
radius: anObject

	radius := anObject! !

!AthensBalloonPaint methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 9/14/2011 17:22'!
asStrokePaint
	^ AthensBalloonStrokePaint new fillPaint: self! !

AthensBalloonPaint subclass: #AthensBalloonSolidColorPaint
	instanceVariableNames: 'color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Balloon'!

!AthensBalloonSolidColorPaint commentStamp: 'IgorStasenko 12/20/2011 15:27' prior: 0!
maybe Color could act as a AthensPaint by itself by implementing a corresponding protocol!

!AthensBalloonSolidColorPaint methodsFor: 'accessing' stamp: 'IgorStasenko 3/22/2011 21:59'!
color

	^ color! !

!AthensBalloonSolidColorPaint methodsFor: 'accessing' stamp: 'IgorStasenko 3/22/2011 21:59'!
color: anObject

	color := anObject! !

!AthensBalloonSolidColorPaint methodsFor: 'rendering' stamp: 'IgorStasenko 3/29/2011 15:00'!
fillPath: athensBalloonPath on: anAthensCanvas 

	^ anAthensCanvas surface 
		fillBezierShape: athensBalloonPath contoursForFilling  
		color: color.
		! !

!AthensBalloonSolidColorPaint methodsFor: 'rendering' stamp: 'IgorStasenko 4/1/2011 09:13'!
fillRectangle: aRect on: canvas
	"This is a terminal method in rendering dispatch scheme
	canvas->shape->paint. See AthensCanvas>>fillShape: "
	

	^ canvas surface fillRectangle: aRect color: color! !

!AthensBalloonSolidColorPaint methodsFor: 'rendering' stamp: 'IgorStasenko 9/14/2011 15:10'!
strokePath: aPath on: anAthensCanvas stroke: strokePaint 
	
	 anAthensCanvas surface 
		strokeBezierShape: aPath contoursForStroke
		color: color
		width: strokePaint width.
		! !

!AthensBalloonSolidColorPaint methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 9/14/2011 15:17'!
strokeRect: rect on: canvas stroke: strokePaint

	^ canvas surface strokeRectangle: rect color: color width: strokePaint width! !

AthensPaint subclass: #AthensCairoSolidColorPaint
	instanceVariableNames: 'color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Cairo'!

!AthensCairoSolidColorPaint methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 15:32'!
color: aColor
	color := aColor! !

!AthensCairoSolidColorPaint methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/21/2011 12:26'!
fillPath: path on: anAthensCanvas 

	anAthensCanvas
		setSourceR: color red g: color green b: color blue a: color alpha.
		
	anAthensCanvas emitPathCommandsFor: path.
	
	anAthensCanvas fill.
		
! !

!AthensCairoSolidColorPaint methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 16:09'!
fillRectangle: aRect on: anAthensCanvas
	"This is a terminal method in rendering dispatch scheme
	canvas->shape->paint. See AthensCanvas>>fillShape: "
	
	
	anAthensCanvas
		setSourceR: color red g: color green b: color blue a: color alpha;
		rectangleX: aRect left y: aRect top width: aRect width height: aRect height;
		fill
	! !

!AthensPaint methodsFor: 'converting' stamp: 'IgorStasenko 4/1/2011 15:18'!
asAthensPaintOn: anAthensCanvas	
	^ self! !

!AthensPaint methodsFor: 'converting' stamp: 'IgorStasenko 9/13/2011 17:46'!
asStrokePaint
	self subclassResponsibility! !

!AthensPaint methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 5/1/2011 23:20'!
fillPath: athensBalloonPath on: anAthensCanvas 

	"This is a terminal method in rendering dispatch scheme
	canvas->shape->paint. See AthensCanvas>>fillShape: "
	
	self subclassResponsibility! !

!AthensPaint methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/23/2011 03:02'!
fillRectangle: aRect on: anAthensCanvas
	"This is a terminal method in rendering dispatch scheme
	canvas->shape->paint. See AthensCanvas>>fillShape: "
	
	self subclassResponsibility! !

AthensPaint subclass: #AthensStrokePaint
	instanceVariableNames: 'fillPaint width capStyle joinStyle innerJoinStyle miterLimit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Core'!

AthensStrokePaint subclass: #AthensBalloonStrokePaint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Balloon'!

!AthensBalloonStrokePaint methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 9/14/2011 15:05'!
fillPath: aPath on: aCanvas

	^ fillPaint strokePath: aPath on: aCanvas stroke: self! !

!AthensBalloonStrokePaint methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 9/14/2011 15:16'!
fillRectangle: aRect on: aCanvas

	^ fillPaint strokeRect: aRect on: aCanvas stroke: self! !

!AthensStrokePaint methodsFor: 'accessing' stamp: 'IgorStasenko 4/29/2011 15:28'!
capStyle

	^ capStyle! !

!AthensStrokePaint methodsFor: 'accessing' stamp: 'IgorStasenko 4/29/2011 15:28'!
capStyle: anObject

	capStyle := anObject! !

!AthensStrokePaint methodsFor: 'accessing' stamp: 'IgorStasenko 4/29/2011 15:28'!
fillPaint

	^ fillPaint! !

!AthensStrokePaint methodsFor: 'accessing' stamp: 'IgorStasenko 4/29/2011 15:28'!
fillPaint: anObject

	fillPaint := anObject! !

!AthensStrokePaint methodsFor: 'initialize-release' stamp: 'IgorStasenko 9/19/2011 15:40'!
initialize
	"initialize defaults"
	
	width := 1.
	capStyle := #butt.
	joinStyle := #bevel.
	innerJoinStyle := #bevel.
	miterLimit := 4.0.! !

!AthensStrokePaint methodsFor: 'accessing' stamp: 'IgorStasenko 4/29/2011 15:28'!
innerJoinStyle

	^ innerJoinStyle! !

!AthensStrokePaint methodsFor: 'accessing' stamp: 'IgorStasenko 4/29/2011 15:28'!
innerJoinStyle: anObject

	innerJoinStyle := anObject! !

!AthensStrokePaint methodsFor: 'accessing' stamp: 'IgorStasenko 4/29/2011 15:28'!
joinStyle

	^ joinStyle! !

!AthensStrokePaint methodsFor: 'accessing' stamp: 'IgorStasenko 4/29/2011 15:28'!
joinStyle: anObject

	joinStyle := anObject! !

!AthensStrokePaint methodsFor: 'accessing' stamp: 'IgorStasenko 4/29/2011 15:28'!
miterLimit

	^ miterLimit! !

!AthensStrokePaint methodsFor: 'accessing' stamp: 'IgorStasenko 4/29/2011 15:28'!
miterLimit: anObject

	miterLimit := anObject! !

!AthensStrokePaint methodsFor: 'accessing' stamp: 'IgorStasenko 9/19/2011 15:40'!
width

	^ width! !

!AthensStrokePaint methodsFor: 'accessing' stamp: 'IgorStasenko 4/29/2011 15:28'!
width: anObject

	width := anObject! !

Object subclass: #AthensParagraph
	instanceVariableNames: 'text textStyle containerRect lines positionWhenComposed selectionStart selectionStop'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Text'!

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 16:08'!
characterBlockForIndex: index 

		^ self defaultCharacterBlock! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 12:22'!
compose: aText style: aTextStyle from: startingIndex in: aRectangle 
	text := aText.
	textStyle := aTextStyle
	
	self shouldBeImplemented.! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 12:50'!
compose: aText style: aTextStyle in: rect 

	text := aText.
	textStyle := aTextStyle.
	containerRect := rect.
	lines := (AthensTextComposer scan: aText for: AthensTextScanner new) lines.! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 13:04'!
defaultCharacterBlock
	^ (CharacterBlock new stringIndex: 1 text: text
			topLeft: 0@0 extent: 0 @ 0)
		textLine: lines first! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 16:30'!
drawOnAthensCanvas: canvas bounds: aRectangle 

	| renderer p1 p2 clip |
	
	"transform clipping bounds "
	p1 := canvas pathTransform transform: aRectangle origin.
	p2 := canvas pathTransform transform: aRectangle corner.
	clip := Rectangle origin:  p1 corner: p2.
		
	canvas
		clipBy: clip 
		during: [  
			renderer := AthensTextRenderer new.
			renderer render: text lines: lines on: canvas.
		].
! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 12:48'!
extent
	^ containerRect width @ lines last bottom! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 13:07'!
extraSelectionChanged
"
	refreshExtraSelection := true
"

	self flag: #foo! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 13:06'!
findReplaceSelectionRegex: aRegex
"	findReplaceSelectionRegex := aRegex. "
	self flag: #foo
! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 12:45'!
focused: bool

	"why we should care?"
	
	"self flag: #ooo"! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 13:00'!
positionWhenComposed: pos
	positionWhenComposed := pos! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 13:06'!
secondarySelection: aSubString
"	secondarySelection := aSubString."
	self flag: #foo.! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 13:02'!
selectionColor: anUndefinedObject 
	self shouldBeImplemented.! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 13:08'!
selectionRects
	^ #()! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 13:09'!
selectionStart: startBlock selectionStop: stopBlock
	selectionStart := startBlock.
	selectionStop := stopBlock.! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 13:05'!
text
	^ text! !

!AthensParagraph methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 12:20'!
textOwner: anUndefinedObject 
	self shouldBeImplemented.! !

Object subclass: #AthensPath
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Core'!

!AthensPath commentStamp: 'IgorStasenko 3/21/2011 03:48' prior: 0!
Internally, all shapes in Athens are converted into paths before drawing.
Path data organization is up to surface where it built,
therefore paths are not interchangeable between different surfaces.!

AthensPath subclass: #AthensBalloonPath
	instanceVariableNames: 'bounds contours last'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Balloon'!

!AthensBalloonPath methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/27/2011 00:23'!
contours
	
	^ contours! !

!AthensBalloonPath methodsFor: 'converting' stamp: 'IgorStasenko 3/29/2011 14:53'!
contoursForFilling
	"answer a collection of contours, ready for filling by balloon engine"
	^ contours collect: [:contour |
		contour last = contour first 
		ifTrue: [contour asArray] 
		ifFalse: [ (contour , { contour last. contour last. contour first }) ]
	]! !

!AthensBalloonPath methodsFor: 'converting' stamp: 'IgorStasenko 9/14/2011 15:08'!
contoursForStroke
	"answer a collection of contours, ready for stroking by balloon engine"
	^ contours collect: [:contour | contour asArray ]! !

!AthensBalloonPath methodsFor: 'converting' stamp: 'IgorStasenko 3/29/2011 14:55'!
convertFromBuilder: aBuilder
	| segment cContours |
	bounds := aBuilder pathBounds.
	segment := aBuilder pathStart.
	

	[ segment notNil ] whileTrue: [
		segment visitWith: self.
		segment := segment next ].
	
	" finally make all OrderedColllections ==> Array "
	cContours := Array new: contours size.
	1 to: cContours size do: [:i |
		cContours at: i put: (contours at: i) asArray.
		].
	contours := cContours.! !

!AthensBalloonPath methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/27/2011 17:40'!
duplicateLastPoint

	contours last size < 2 ifFalse: [
		"duplicate last contour point"
		contours last add: (contours last last).
		]. 
! !

!AthensBalloonPath methodsFor: 'accessing' stamp: 'IgorStasenko 3/27/2011 13:54'!
numContours
	^ contours size! !

!AthensBalloonPath methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/27/2011 00:15'!
paintFillsUsing: aPaint on: anAthensCanvas 
	
	"This method is a part of rendering dispatch  Canvas->receiver->paint"
	
	^ aPaint fillPath: self on: anAthensCanvas! !

!AthensBalloonPath methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 9/13/2011 16:21'!
paintStrokeUsing: paint on: anAthensCanvas 
	
	^ paint strokePath: self on: anAthensCanvas
! !

!AthensBalloonPath methodsFor: 'converting' stamp: 'IgorStasenko 3/27/2011 17:31'!
visitCloseSegment: closeSegment
	
	"see if its alredy closed"
	contours last last = contours last first ifFalse: [
		
		contours last 
			add: (contours last last);
			add: closeSegment endPoint;
			add: closeSegment endPoint
	]! !

!AthensBalloonPath methodsFor: 'converting' stamp: 'IgorStasenko 3/27/2011 17:40'!
visitLineSegment: line
	self duplicateLastPoint.
	contours last add: line endPoint;
		add: line endPoint.! !

!AthensBalloonPath methodsFor: 'converting' stamp: 'IgorStasenko 3/27/2011 00:05'!
visitMoveSegment: seg
	
	contours ifNil: [
		contours := OrderedCollection new ].
	
	contours add: OrderedCollection new.
	contours last add: seg endPoint.! !

!AthensBalloonPath methodsFor: 'converting' stamp: 'IgorStasenko 3/27/2011 17:40'!
visitQuadSegment: quadSegment

	self duplicateLastPoint.

	contours last add: quadSegment via;
		add: quadSegment to! !

AthensPath subclass: #AthensCairoPath
	instanceVariableNames: 'builder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Cairo'!

!AthensCairoPath methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 18:32'!
builder: aBuilder
	builder := aBuilder! !

!AthensCairoPath methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 18:33'!
paintFillsUsing: aPaint on: anAthensCanvas 
	
	"This method is a part of rendering dispatch  Canvas->receiver->paint"
	
	^ aPaint fillPath: self on: anAthensCanvas! !

!AthensCairoPath methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/21/2011 12:34'!
pathStart
	^ builder pathStart! !

!AthensPath methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/22/2011 22:47'!
numSegments
	"answer a number of segments path contains"
	
	self subclassResponsibility! !

Object subclass: #AthensPathBuilder
	instanceVariableNames: 'absolute open contourStartPt xMin yMin xMax yMax pathStart lastSegment'
	classVariableNames: 'ZeroPoint'
	poolDictionaries: ''
	category: 'Athens-Core-Paths'!

!AthensPathBuilder classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/21/2011 03:40'!
initialize
	ZeroPoint := 0@0! !

!AthensPathBuilder methodsFor: 'path commands' stamp: 'IgorStasenko 3/21/2011 03:40'!
absolute
	absolute := true.! !

!AthensPathBuilder methodsFor: 'private' stamp: 'IgorStasenko 3/26/2011 16:32'!
addSegment: aSegment
	lastSegment next: aSegment.
	lastSegment := aSegment.
 ! !

!AthensPathBuilder methodsFor: 'path commands' stamp: 'IgorStasenko 3/26/2011 16:47'!
close
	"close the current contour"
	self addSegment: (AthensCloseSegment new point: contourStartPt).

	contourStartPt := nil.
	open := false! !

!AthensPathBuilder methodsFor: 'path commands' stamp: 'IgorStasenko 3/26/2011 19:26'!
curveVia: cp1 and: cp2 to: aPoint
	"Cubic bezier curve"
	
	| pt1 pt2 pt3 |
	"Quad bezier curve"

	pt1 := self toAbsolute: cp1.
	pt2 := self toAbsolute: cp2.
	pt3 := self toAbsolute: aPoint.
	^ self addSegment: (
		AthensCubicSegment new 
			from: lastSegment endPoint 
			via: pt1
			and: pt2
			to: pt3)

! !

!AthensPathBuilder methodsFor: 'path commands' stamp: 'IgorStasenko 3/26/2011 16:51'!
curveVia: cp1 to: aPoint
	| pt1 pt2 |
	"Quad bezier curve"

	pt1 := self toAbsolute: cp1.
	pt2 := self toAbsolute: aPoint.
	^ self addSegment: (
		AthensQuadSegment new 
			from: lastSegment endPoint 
			via: pt1 
			to: pt2)

! !

!AthensPathBuilder methodsFor: 'initialize-release' stamp: 'IgorStasenko 5/2/2011 05:39'!
initialize
	absolute := false.
	contourStartPt := ZeroPoint.
	pathStart := lastSegment := (AthensMoveSegment new  point: ZeroPoint).! !

!AthensPathBuilder methodsFor: 'path commands' stamp: 'IgorStasenko 3/26/2011 16:45'!
lineTo: aPoint

	^ self addSegment: (AthensLineSegment new point: (self toAbsolute: aPoint)).

! !

!AthensPathBuilder methodsFor: 'path commands' stamp: 'IgorStasenko 3/26/2011 16:50'!
moveTo: aPoint
	" move command always starts a new contour "
	contourStartPt := self toAbsolute: aPoint.
	
	"collapse multiple moves to a single one"
	lastSegment isMove ifTrue: [
		lastSegment point: contourStartPt.
		^ self
	].

	self addSegment: (AthensMoveSegment new point: contourStartPt; reopen: open).
	open := true.! !

!AthensPathBuilder methodsFor: 'accessing' stamp: 'IgorStasenko 3/26/2011 19:40'!
pathBounds
	^ xMin@yMin corner: xMax@yMax! !

!AthensPathBuilder methodsFor: 'accessing' stamp: 'IgorStasenko 3/26/2011 19:50'!
pathStart
	^ pathStart! !

!AthensPathBuilder methodsFor: 'path commands' stamp: 'IgorStasenko 3/21/2011 03:40'!
relative
	absolute := false.! !

!AthensPathBuilder methodsFor: 'private' stamp: 'IgorStasenko 3/26/2011 16:43'!
toAbsolute: aPoint
	| pt |
	pt := absolute 
		ifTrue: [ aPoint ]
		ifFalse: [ lastSegment endPoint + aPoint ].

	"note the coordinate to calculate the path's bounding box"
	xMin ifNil: [
		xMin := xMax := pt x.
		yMin := yMax := pt y.	
		] 
	ifNotNil: [
		xMin := pt x min: xMin.
		yMin := pt y min: yMin.
		xMax := pt x max: xMax.
		yMax := pt y max: yMax.	
	].
	^ pt! !

Object subclass: #AthensPathConverter
	instanceVariableNames: 'sourcePath dest endPoint'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Core-Paths'!

!AthensPathConverter commentStamp: 'IgorStasenko 5/1/2011 23:14' prior: 0!
i am a base class for path conversion. 
i take a path as input and producing a path commands as output.

My default implementation just passing all path commands without changes to destination without any conversion

Example of use:

 
converter := AthensXYZConverter dest: (AthensPolygonPath new).
convertedPath := converter convert: sourcePath.

You can chain multiple converters:

basicConverter := AthensZYXConv dest: AthensPolygonPath new. 
compoundConverter := AthensABCConverter dest: basicConverter.

compoundConverter convert: somePath

in this case, an initial conversion is performed by instance of AthensABCConverter, and then conversion results are passed down to AthensZYXConv,
and then finally to instance of AthensPolygonPath.
!

AthensPathConverter subclass: #AthensBezierConverter
	instanceVariableNames: 'distanceTolerance angleTolerance'
	classVariableNames: 'CollinearityEps CurveAngleTolerance DistanceEps'
	poolDictionaries: ''
	category: 'Athens-Core-Paths'!

!AthensBezierConverter commentStamp: 'IgorStasenko 5/1/2011 21:50' prior: 0!
I converting all bezier segments to a sequence of line segments, by approximating the curve along its path.

This classs is used for generating strokes.!

!AthensBezierConverter classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 4/29/2011 18:10'!
initialize

	CollinearityEps := 1e-30.
	DistanceEps := 1e-30.
	CurveAngleTolerance := 0.01.! !

!AthensBezierConverter methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 5/1/2011 21:45'!
angleBetween: p1 and: p2 ifDegenerate: aBlock

" Calculate an angle (in radians) between two vectors. 
Evaluate a block, in case if calculation not possible because one of the vectors has zero length "

	| x1 y1 x2 y2 dot2 n2 |
	x1 := p1 x.
	y1 := p1 y.
	x2 := p2 x.
	y2 := p2 y.
	
	dot2 := x1 * x2 + (y1 * y2).
	dot2 := dot2 * dot2.
	
	n2 := (x1*x1 + (y1*y1)) * (x2*x2 + (y2*y2)).
	
	n2 = 0 ifTrue: [ ^ aBlock value ].
	
	^ (dot2 / n2) arcCos! !

!AthensBezierConverter methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 5/1/2011 22:03'!
curveVia: pt1 to: pt2


	self	 recursiveBezier2_x1: endPoint x y1: endPoint y
		x2: pt1 x y2: pt1 y
		x3: pt2 x y3: pt2 y! !

!AthensBezierConverter methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 4/29/2011 18:11'!
initialize

	distanceTolerance := 0.5.
	angleTolerance := 0.1 . ! !

!AthensBezierConverter methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 4/29/2011 18:09'!
isFlatBezier2_x1: x1 y1: y1 x2: x2 y2: y2 x3: x3 y3: y3

	| dx dy d da angle |
	
	dx := x3-x1.
	dy := y3-y1.
	
 	d := (((x2 - x3) * dy) - ((y2 - y3) * dx)) abs.

	d > CollinearityEps ifTrue: [
		
		"regular case"

		d*d <= (distanceTolerance * ( dx*dx + (dy*dy))) ifTrue: [
			
			angleTolerance < CurveAngleTolerance ifTrue: [ ^ true ].
			
			angle := self angleBetween: x2-x1 @ (y2-y1) and: x3-x2 @ (y3-y2)
				ifDegenerate: [ 0.0 ].
			
			"parallel. no need to proceed further"
			angle <= angleTolerance ifTrue: [ ^ true ]					
		]
	]
	ifFalse: [ 
		"collinear"
		da := dx*dx + (dy*dy).
		
		da = 0 
			ifTrue: [ d := (x1-x2) squared + (y1-y2) squared ]
			ifFalse: [
				d = ((x2 - x1)*dx + ((y2 - y1)*dy)) / da.

				(d > 0.0 and: [ d < 1.0 ] ) ifTrue: [ 
					"Simple collinear case, 1---2---3" 
					^ true
     				].
				d <= 0.0 
					ifTrue: [ d := (x1-x2) squared + (y1-y2) squared ]
					ifFalse: [
						d >= 1.0 
							ifTrue: [ d:= (x2-x3) squared + (y2-y3) squared ]
							ifFalse: [ d:= (x2 - x1 - (d*dx)) squared + (y2 - y1 - (d*dy)) squared ]
					].
			].

			d < self distanceToleranceSquared ifTrue: [ ^ true ]		
	].

	^ false! !

!AthensBezierConverter methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 5/1/2011 21:47'!
recursiveBezier2_x1: x1 y1: y1 x2: x2 y2: y2 x3: x3 y3: y3

	"recursively subdive bezier curve as long as #isFlatBezier2.. answers false "

	(self isFlatBezier2_x1: x1 y1: y1 x2: x2 y2: y2 x3: x3 y3: y3) ifTrue: [
		
		dest 
			lineTo: x2 @ y2;
			lineTo: x3 @ y3
	] ifFalse: [
		| x12 y12 x23 y23 x123 y123 |	
	"calculate midpoints of line segments "
		x12 := (x1 + x2) * 0.5.
		y12 := (y1 + y2) * 0.5 .

		x23 := (x2 + x3) * 0.5 .
		y23 := (y2 + y3) * 0.5 .

		x123 := (x12 + x23) * 0.5.
		y123 := (y12 + y23) * 0.5.
		
		self recursiveBezier2_x1: x1 y1: y1 
			x2: x12 
			y2: y12 
			x3: x123 
			y3: y123.
			
		self recursiveBezier2_x1: x123 
			y1: y123
			x2: x23
			y2: y23 
			x3: x3 
			y3: y3.
	]
! !

!AthensPathConverter classSide methodsFor: 'instance creation' stamp: 'IgorStasenko 5/1/2011 22:18'!
dest: aDest

	^ self new dest: aDest! !

!AthensPathConverter classSide methodsFor: 'instance creation' stamp: 'IgorStasenko 5/1/2011 22:20'!
source: aSource dest: aDest
	" answer a converted path from source to dest, using my instance as a converter"
	
	^ self new source: aSource dest: aDest! !

!AthensPathConverter methodsFor: 'converting path commands' stamp: 'IgorStasenko 5/2/2011 05:18'!
close: aPoint 
	^ dest close: aPoint! !

!AthensPathConverter methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 5/1/2011 22:16'!
convert: aSourcePath
	
	" iterate over segments and do conversion "
	
	| segment |
	
	segment := aSourcePath.
	
	[ segment notNil ] whileTrue: [
		segment convertWith: self.
		endPoint := segment endPoint.
		segment := segment next.
	].

	^ dest finish! !

!AthensPathConverter methodsFor: 'converting path commands' stamp: 'IgorStasenko 4/29/2011 18:31'!
curveVia: pt1 to: pt2

	^ dest curveVia: pt1 to: pt2
! !

!AthensPathConverter methodsFor: 'accessing' stamp: 'IgorStasenko 5/1/2011 22:18'!
dest: anObject
	dest := anObject! !

!AthensPathConverter methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 5/1/2011 22:13'!
finish
	^ dest finish! !

!AthensPathConverter methodsFor: 'converting path commands' stamp: 'IgorStasenko 4/29/2011 18:36'!
lineTo: aPoint 
	^ dest lineTo: aPoint! !

!AthensPathConverter methodsFor: 'converting path commands' stamp: 'IgorStasenko 4/29/2011 18:28'!
moveTo: aPoint 
	^ dest moveTo: aPoint! !

!AthensPathConverter methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 4/29/2011 18:18'!
source: aSource dest: aDest

	sourcePath := aSource.
	dest := aDest! !

Object subclass: #AthensPathSegment
	instanceVariableNames: 'next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Core-Paths'!

AthensPathSegment subclass: #AthensCubicSegment
	instanceVariableNames: 'via1 via2 to'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Core-Paths'!

!AthensCubicSegment methodsFor: 'visitor' stamp: 'IgorStasenko 4/29/2011 18:16'!
convertWith: conv

	^ conv curveVia: via1 and: via2 to: to! !

!AthensCubicSegment methodsFor: 'visitor' stamp: 'IgorStasenko 3/26/2011 19:37'!
visitWith: anObject

	^ anObject visitCubicSegment: self! !

AthensPathSegment subclass: #AthensLineSegment
	instanceVariableNames: 'point'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Core-Paths'!

AthensLineSegment subclass: #AthensCloseSegment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Core-Paths'!

!AthensCloseSegment methodsFor: 'visitor' stamp: 'IgorStasenko 4/29/2011 18:14'!
convertWith: conv

	^ conv close: point! !

!AthensCloseSegment methodsFor: 'visitor' stamp: 'IgorStasenko 3/26/2011 19:38'!
visitWith: anObject

	^ anObject visitCloseSegment: self! !

!AthensLineSegment methodsFor: 'visitor' stamp: 'IgorStasenko 4/29/2011 18:14'!
convertWith: conv

	^ conv lineTo: point! !

!AthensLineSegment methodsFor: 'accessing' stamp: 'IgorStasenko 3/26/2011 16:21'!
endPoint
	^ point! !

!AthensLineSegment methodsFor: 'accessing' stamp: 'IgorStasenko 3/26/2011 16:16'!
point

	^ point! !

!AthensLineSegment methodsFor: 'accessing' stamp: 'IgorStasenko 3/26/2011 16:16'!
point: anObject

	point := anObject! !

!AthensLineSegment methodsFor: 'visitor' stamp: 'IgorStasenko 3/26/2011 19:38'!
visitWith: anObject

	^ anObject visitLineSegment: self! !

AthensLineSegment subclass: #AthensMoveSegment
	instanceVariableNames: 'closed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Core-Paths'!

!AthensMoveSegment commentStamp: 'IgorStasenko 5/2/2011 05:35' prior: 0!
Move segment always indicates starting of a new contour.
If contour ends with close command, then my insntance will have 'closed' flag set to true.

See AthensPathBuilder , which is responsible for building paths.!

!AthensMoveSegment methodsFor: 'accessing' stamp: 'IgorStasenko 5/2/2011 05:37'!
closed: aBoolean
	closed := aBoolean! !

!AthensMoveSegment methodsFor: 'visitor' stamp: 'IgorStasenko 4/29/2011 18:14'!
convertWith: conv

	^ conv moveTo: point! !

!AthensMoveSegment methodsFor: 'testing' stamp: 'IgorStasenko 5/2/2011 05:37'!
isClosed
	^ closed == true! !

!AthensMoveSegment methodsFor: 'testing' stamp: 'IgorStasenko 3/27/2011 17:48'!
isMove
	^ true! !

!AthensMoveSegment methodsFor: 'visitor' stamp: 'IgorStasenko 3/26/2011 19:38'!
visitWith: anObject

	^ anObject visitMoveSegment: self! !

!AthensPathSegment methodsFor: 'visitor' stamp: 'IgorStasenko 4/29/2011 18:13'!
convertWith: anObject
	self subclassResponsibility! !

!AthensPathSegment methodsFor: 'testing' stamp: 'IgorStasenko 3/26/2011 16:44'!
isMove
	^ false! !

!AthensPathSegment methodsFor: 'accessing' stamp: 'IgorStasenko 3/26/2011 16:14'!
next

	^ next! !

!AthensPathSegment methodsFor: 'accessing' stamp: 'IgorStasenko 3/26/2011 16:14'!
next: anObject

	next := anObject! !

!AthensPathSegment methodsFor: 'visitor' stamp: 'IgorStasenko 3/26/2011 19:36'!
visitWith: anObject

	self subclassResponsibility! !

AthensPathSegment subclass: #AthensQuadSegment
	instanceVariableNames: 'via to'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Core-Paths'!

!AthensQuadSegment commentStamp: 'IgorStasenko 12/21/2011 12:21' prior: 0!
Any quadratic spline can be expressed as a cubic (where the cubic term is zero). The end points of the cubic will be the same as the quadratic's.

    CP0 = QP0
    CP3 = QP2 

The two control points for the cubic are:

    CP1 = QP0 + 2/3 *(QP1-QP0)
    CP2 = QP2 + 2/3 *(QP1-QP2) !

!AthensQuadSegment methodsFor: 'visitor' stamp: 'IgorStasenko 4/29/2011 18:15'!
convertWith: conv

	^ conv curveVia: via to: to! !

!AthensQuadSegment methodsFor: 'accessing' stamp: 'IgorStasenko 3/26/2011 16:52'!
endPoint
	^ to! !

!AthensQuadSegment methodsFor: 'initialize-release' stamp: 'IgorStasenko 3/26/2011 16:52'!
from: pt0 via: pt1 to: p

	via := pt1.
	to := p.! !

!AthensQuadSegment methodsFor: 'accessing' stamp: 'IgorStasenko 3/26/2011 16:52'!
to

	^ to! !

!AthensQuadSegment methodsFor: 'accessing' stamp: 'IgorStasenko 3/26/2011 16:52'!
via

	^ via! !

!AthensQuadSegment methodsFor: 'visitor' stamp: 'IgorStasenko 3/26/2011 19:38'!
visitWith: anObject

	^ anObject visitQuadSegment: self! !

Object subclass: #AthensPolygon
	instanceVariableNames: 'contours currentContour'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Core-Paths'!

!AthensPolygon commentStamp: 'IgorStasenko 12/20/2011 18:38' prior: 0!
i am special kind of shape which using only straight line segments, unlike from more generic paths.!

!AthensPolygon methodsFor: 'conversion' stamp: 'IgorStasenko 5/1/2011 22:11'!
finish
	"Finally convert contours to arrays"
	
	contours := contours collect: [:ea | ea asArray ]! !

!AthensPolygon methodsFor: 'conversion' stamp: 'IgorStasenko 4/29/2011 18:32'!
lineTo: aPoint 
	currentContour add: aPoint! !

!AthensPolygon methodsFor: 'conversion' stamp: 'IgorStasenko 4/29/2011 18:29'!
moveTo: aPoint 
	" create a new contour "
	
	self newContour.
	currentContour add: aPoint.! !

!AthensPolygon methodsFor: 'conversion' stamp: 'IgorStasenko 4/29/2011 18:30'!
newContour
	contours ifNil: [ contours := OrderedCollection new ].
	
	currentContour := contours add: OrderedCollection new.! !

!AthensPolygon methodsFor: 'drawing' stamp: 'IgorStasenko 5/2/2011 04:48'!
paintFillsUsing: aPaint on: anAthensCanvas 
	
	"This method is a part of rendering dispatch  Canvas->receiver->paint"
	
	^ aPaint fillPolygon: self on: anAthensCanvas! !

Object subclass: #AthensShape
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Core'!

!AthensShape commentStamp: 'IgorStasenko 12/20/2011 18:36' prior: 0!
this is an abstract class to denote a common protocol, which must be supported by any shapes used for rendering by Athens!

!AthensShape methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 18:36'!
paintFillsUsing: aPaint on: anAthensCanvas 
	"This method is a part of rendering dispatch  Canvas->receiver->paint"
	
	self subclassResponsibility! !

Object subclass: #AthensSurface
	instanceVariableNames: 'currentCanvas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Core'!

AthensSurface subclass: #AthensBalloonSurface
	instanceVariableNames: 'form mask maskEnabled pathTransform imageTransform fillTransform strokeTransform engine'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Balloon'!

!AthensBalloonSurface methodsFor: 'testing' stamp: 'IgorStasenko 4/1/2011 09:36'!
clearForm

	form bits: ( Bitmap new: form bits size).
	! !

!AthensBalloonSurface methodsFor: 'clipping' stamp: 'IgorStasenko 4/21/2011 14:55'!
clipBy: aRectangle during: aBlock

	| oldRect |
	
	oldRect := engine clipRect.
	engine clipRect: (oldRect intersect: aRectangle).

	aBlock ensure: [ engine clipRect: oldRect ]! !

!AthensBalloonSurface methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 16:33'!
clipRect
	^ engine clipRect! !

!AthensBalloonSurface methodsFor: 'paints' stamp: 'IgorStasenko 4/14/2011 17:12'!
createCircularGradient: colorRamp center: aCenter radius: aRadius

	^ AthensBalloonRadialGradient new
		colorRamp: colorRamp;
		center: aCenter;
		radius: aRadius;
		yourself! !

!AthensBalloonSurface methodsFor: 'paints' stamp: 'IgorStasenko 4/21/2011 15:49'!
createImagePaint: aForm  
	^ AthensBalloonImagePaint new
		form: aForm! !

!AthensBalloonSurface methodsFor: 'paints' stamp: 'IgorStasenko 4/1/2011 10:48'!
createLinearGradient: colorRamp origin: pt1 corner: pt2
 
	^ AthensBalloonLinearGradient new
		colorRamp: colorRamp;
		origin: pt1;
		corner: pt2;
		yourself! !

!AthensBalloonSurface methodsFor: 'paths' stamp: 'IgorStasenko 3/26/2011 20:10'!
createPath: aPathBuilder
	"Create a path from provided path builder instance"
	
	^ AthensBalloonPath new 
		convertFromBuilder: aPathBuilder.
	
	! !

!AthensBalloonSurface methodsFor: 'paths' stamp: 'IgorStasenko 4/1/2011 15:08'!
createRectanglePath: aRectangle 
	"In balloon implementation, rectangles don't require conversion and can be used directly" 
	^ aRectangle! !

!AthensBalloonSurface methodsFor: 'paints' stamp: 'IgorStasenko 3/22/2011 21:59'!
createSolidColorPaint: aColor 
	^ AthensBalloonSolidColorPaint new color: aColor! !

!AthensBalloonSurface methodsFor: 'masking' stamp: 'IgorStasenko 3/27/2011 18:16'!
disableMask
	maskEnabled := false.! !

!AthensBalloonSurface methodsFor: 'drawing' stamp: 'IgorStasenko 4/21/2011 16:35'!
drawImage: aForm 

	engine drawImage: aForm transform: imageTransform! !

!AthensBalloonSurface methodsFor: 'masking' stamp: 'IgorStasenko 3/27/2011 18:16'!
enableMask
	maskEnabled := true! !

!AthensBalloonSurface methodsFor: 'accessing' stamp: 'IgorStasenko 3/27/2011 20:30'!
engine
	^ engine! !

!AthensBalloonSurface methodsFor: 'drawing' stamp: 'IgorStasenko 4/1/2011 09:25'!
fillBezierShape: contours color: aColor 

	engine
		prepareForRendering;
		registerColorFill: aColor	;
		fillBezierShape: contours! !

!AthensBalloonSurface methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 9/14/2011 15:08'!
fillBezierShape: anArray color: aColor width: aSmallInteger 
	self shouldBeImplemented.! !

!AthensBalloonSurface methodsFor: 'drawing' stamp: 'IgorStasenko 4/1/2011 09:24'!
fillRectangle: rect color: aColor

	engine
		prepareForRendering;
		registerColorFill: aColor	;
		fillRectangle: rect
! !

!AthensBalloonSurface methodsFor: 'accessing matrices' stamp: 'IgorStasenko 3/26/2011 02:12'!
fillTransform

	^ fillTransform! !

!AthensBalloonSurface methodsFor: 'accessing matrices' stamp: 'IgorStasenko 3/26/2011 02:12'!
fillTransform: anObject

	fillTransform := anObject! !

!AthensBalloonSurface methodsFor: 'accessing' stamp: 'IgorStasenko 3/21/2011 15:10'!
form
	^ form! !

!AthensBalloonSurface methodsFor: 'accessing' stamp: 'IgorStasenko 4/21/2011 16:17'!
form: aForm

	form := aForm.
	mask := Form extent: form extent depth: 1. 

	engine := AthensBalloonEngine new.
	engine bitBlt: (GrafPort toForm: form) .
	engine clipRect: (0@0 extent: form extent).
	engine edgeTransform: pathTransform.
	engine destOffset: 0@0.
	engine reset.! !

!AthensBalloonSurface methodsFor: 'fonts' stamp: 'IgorStasenko 10/20/2011 10:03'!
getFreetypeFontRendererFor: aFreeTypeFont 
	
	^ (FT2GlyphRenderer forFont: aFreeTypeFont surface: self)! !

!AthensBalloonSurface methodsFor: 'accessing matrices' stamp: 'IgorStasenko 3/26/2011 02:12'!
imageTransform

	^ imageTransform! !

!AthensBalloonSurface methodsFor: 'accessing matrices' stamp: 'IgorStasenko 9/19/2011 16:09'!
imageTransform: anObject

	^ imageTransform := anObject copy! !

!AthensBalloonSurface methodsFor: 'initialize-release' stamp: 'IgorStasenko 4/21/2011 18:10'!
initialize
	pathTransform := AthensAffineTransform new.
	imageTransform := AthensAffineTransform new " AthensGenericTransform new".
	fillTransform := AthensAffineTransform new.
	strokeTransform := AthensAffineTransform new.
	maskEnabled := false.! !

!AthensBalloonSurface methodsFor: 'masking' stamp: 'IgorStasenko 3/27/2011 18:17'!
maskEnabled
	^ maskEnabled! !

!AthensBalloonSurface methodsFor: 'accessing matrices' stamp: 'IgorStasenko 3/26/2011 02:12'!
pathTransform

	^ pathTransform! !

!AthensBalloonSurface methodsFor: 'accessing matrices' stamp: 'IgorStasenko 10/17/2011 13:52'!
pathTransform: anObject

	pathTransform := anObject copy.
	engine edgeTransform: pathTransform.! !

!AthensBalloonSurface methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 9/14/2011 15:12'!
strokeBezierShape: contours color: aColor width: aWidth 
	
	engine
		prepareForRendering;
		registerColorFill: aColor	;
		strokeBezierShape: contours width: aWidth! !

!AthensBalloonSurface methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 9/14/2011 15:24'!
strokeRectangle: rect color: aColor width: aWidth
	 
	engine
		prepareForRendering;
		registerColorFill: aColor	;
		strokeRectangle: rect width: aWidth! !

!AthensBalloonSurface methodsFor: 'accessing matrices' stamp: 'IgorStasenko 3/26/2011 02:12'!
strokeTransform

	^ strokeTransform! !

!AthensBalloonSurface methodsFor: 'accessing matrices' stamp: 'IgorStasenko 3/26/2011 02:12'!
strokeTransform: anObject

	strokeTransform := anObject! !

AthensSurface subclass: #AthensCairoSurface
	instanceVariableNames: 'handle'
	classVariableNames: ''
	poolDictionaries: 'AthensCairoDefs'
	category: 'Athens-Cairo'!

!AthensCairoSurface commentStamp: 'IgorStasenko 12/20/2011 15:54' prior: 0!
my instance are mapped to cairo_image_surface_t* C type !

!AthensCairoSurface classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 14:49'!
asNBExternalType: gen
	"use handle ivar to hold my instance (cairo_surface_t)"
	^ NBExternalObjectType objectClass: self! !

!AthensCairoSurface classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 14:58'!
extent: aPoint

	^ self width: aPoint x height: aPoint y! !

!AthensCairoSurface classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/16/2011 11:38'!
nbLibraryNameOrHandle
	^ '/opt/local/lib/libcairo.2.dylib'! !

!AthensCairoSurface classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 15:01'!
primWidth: aWidth height: aHeight
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #( AthensCairoSurface cairo_image_surface_create (
						CAIRO_FORMAT_ARGB32,
						int aWidth,
						int aHeight) )! !

!AthensCairoSurface classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 15:02'!
width: aWidth height: aHeight
	^ (self primWidth: aWidth height: aHeight) initialize! !

!AthensCairoSurface methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 15:19'!
asForm

	"create a form and copy an image data there"
	
	| form bytesToCopy|
	
	form := Form extent: self extent depth: 32.
	
	bytesToCopy := self stride * self height.
	
	bytesToCopy > (form bits size * 4) ifTrue: [
		self error: 'cannot copy data' ].
	
	NativeBoost memCopy: self getDataPtr to: form bits size: 	bytesToCopy.
		
	^ form

"	(Form extent: 10@10 depth: 32) bits size => 100 "! !

!AthensCairoSurface methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 15:38'!
clear
	"clear the surface"
	
! !

!AthensCairoSurface methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 18:32'!
createPath: aPathBuilder
	"Create a path from provided path builder instance"
	
	^ AthensCairoPath new builder: aPathBuilder! !

!AthensCairoSurface methodsFor: 'paints' stamp: 'IgorStasenko 12/20/2011 15:29'!
createSolidColorPaint: aColor 

	^ AthensCairoSolidColorPaint new color: aColor! !

!AthensCairoSurface methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 14:58'!
destroy
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(
		void cairo_surface_destroy ( self ) )

! !

!AthensCairoSurface methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 15:18'!
extent
	^ self width @ self height! !

!AthensCairoSurface methodsFor: 'finalization' stamp: 'IgorStasenko 12/20/2011 15:01'!
finalize
	handle value = 0 ifFalse: [
		self destroy.
		handle value: 0
		 ].
! !

!AthensCairoSurface methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 15:19'!
getDataPtr
	"get a pointer to surface bitmap data"
	
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(
		void* cairo_image_surface_get_data ( self ) )

! !

!AthensCairoSurface methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 15:12'!
height
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(
		int cairo_image_surface_get_height ( self ) )

! !

!AthensCairoSurface methodsFor: 'initialize-release' stamp: 'IgorStasenko 12/20/2011 16:48'!
initialize
	
	handle value = 0 ifTrue: [ 
		self error: 'Error creating new surface' ].
	
	"register to be finalized"
	WeakRegistry default add: self! !

!AthensCairoSurface methodsFor: 'nb helper' stamp: 'IgorStasenko 12/16/2011 11:38'!
nbLibraryNameOrHandle
	^ self class nbLibraryNameOrHandle
! !

!AthensCairoSurface methodsFor: 'private' stamp: 'IgorStasenko 12/20/2011 15:43'!
newCanvas
	"Answer a preinitialized instance of AthensCanvas.
	Private to receiver and its subclasses, override seldom"
	^ AthensCairoCanvas on: self
! !

!AthensCairoSurface methodsFor: 'private' stamp: 'IgorStasenko 12/20/2011 15:55'!
releaseCanvas

	currentCanvas destroy! !

!AthensCairoSurface methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 15:10'!
stride
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(
		int cairo_image_surface_get_stride ( self ) )

! !

!AthensCairoSurface methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 15:12'!
width
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(
		int cairo_image_surface_get_width ( self ) )

! !

!AthensSurface methodsFor: 'public' stamp: 'IgorStasenko 12/20/2011 15:38'!
clear
	"clear the surface"
	
	self subclassResponsibility! !

!AthensSurface methodsFor: 'clipping' stamp: 'IgorStasenko 4/21/2011 14:47'!
clipBy: aRectangle during: aBlockClosure 
	self subclassResponsibility.! !

!AthensSurface methodsFor: 'paints' stamp: 'IgorStasenko 4/21/2011 15:35'!
createImagePaint: aForm offset: aPoint extent: anExtent 
	self subclassResponsibility.! !

!AthensSurface methodsFor: 'paints' stamp: 'IgorStasenko 4/13/2011 17:45'!
createLinearGradient: colorRamp origin: pt1 corner: pt2
 
	self subclassResponsibility! !

!AthensSurface methodsFor: 'paths' stamp: 'IgorStasenko 3/26/2011 19:32'!
createPath: aPathBuilder
	"Create a path from provided path builder instance"
	self subclassResponsibility! !

!AthensSurface methodsFor: 'paints' stamp: 'IgorStasenko 12/20/2011 15:25'!
createSolidColorPaint: aColor 
	 "Answer an instance of AthensPaint, valid for use with given surface"
	
	self subclassResponsibility! !

!AthensSurface methodsFor: 'masking' stamp: 'IgorStasenko 3/27/2011 18:15'!
disableMask
	self subclassResponsibility! !

!AthensSurface methodsFor: 'public' stamp: 'IgorStasenko 3/21/2011 02:33'!
drawDuring: aBlock

	"You may draw on receiver only when inside a block and only using provided canvas object.
	This ensures releasing system resources used when drawing"


	currentCanvas ifNotNil: [ self attemptToRecurseDrawing ].
	
	[
		currentCanvas := self newCanvas.
		aBlock value: currentCanvas.
	] ensure: [
		self releaseCanvas.
		currentCanvas := nil.
	].! !

!AthensSurface methodsFor: 'masking' stamp: 'IgorStasenko 3/27/2011 18:15'!
enableMask
	self subclassResponsibility! !

!AthensSurface methodsFor: 'masking' stamp: 'IgorStasenko 3/27/2011 18:16'!
maskEnabled
	self subclassResponsibility! !

!AthensSurface methodsFor: 'private' stamp: 'IgorStasenko 3/21/2011 02:35'!
newCanvas
	"Answer a preinitialized instance of AthensCanvas.
	Private to receiver and its subclasses, override seldom"
	^ AthensCanvas on: self
! !

!AthensSurface methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/22/2011 22:40'!
releaseCanvas
	currentCanvas := nil! !

Object subclass: #AthensSurfaceExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Examples'!

!AthensSurfaceExamples commentStamp: 'IgorStasenko 4/1/2011 15:29' prior: 0!
AthensBalloonSurfaceExamples example1.
AthensBalloonSurfaceExamples example2.

AthensBalloonSurfaceExamples example6.!

AthensSurfaceExamples subclass: #AthensCairoSurfaceExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Examples'!

!AthensCairoSurfaceExamples classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 15:36'!
newSurface: extent
	
	^ AthensCairoSurface extent: extent! !

!AthensSurfaceExamples classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 16:17'!
example1

"
self example1
"
	| surf |
	
	surf := self newSurface: 100@100.
	
	surf drawDuring: [:can |
		surf clear.
		can pathTransform loadIdentity.
		can pathTransform translateX: 30 Y: 30.
		can pathTransform rotateByDegrees: 35.
		can setPaint: (Color red).
		
		2 timesRepeat: [
		can drawShape: (-20@ -20 corner: 20@ 20).
	]
	].
	Display getCanvas drawImage: 	surf asForm  at: 0@0
! !

!AthensSurfaceExamples classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 4/21/2011 18:20'!
example10
"Draw two rectangles, filled by radial gradient. 
Rotate the gradient in a loop.

Note that it should produce same rectangles with exact same fills, because gradient paint 
coordinates are affected by pathTransform matrix.
"

	| surf paint f bf |
	
	surf := AthensBalloonSurface new
		form: (Form extent: 200@200 depth: 32).
	
	surf form getCanvas fillRectangle: surf form boundingBox color: Color gray.
	
	f := Form extent: 10@10 depth: 32.
	f getCanvas fillRectangle: (0@0 corner: 5@5) color: (Color red alpha: 1).
	f getCanvas fillRectangle: (5@5 corner: 10@10) color: (Color green alpha: 0.3).

	surf drawDuring: [:can |

			can drawImage: f.
			Display getCanvas drawImage: 	surf form  at: 0@0
	].

! !

!AthensSurfaceExamples classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 18:50'!
example2
"
self example2
"

	| surf |
	
	surf := self newSurface: 100@100.
	
	surf drawDuring: [:can |
		surf clear.
		
		can setPaint: Color blue.
		
		can drawShape: (
			can createPath: [:path |
				path 
					absolute;
					lineTo: 50@0;
					lineTo: 50@50;
					lineTo: 0@50
			])
	
	].

	Display getCanvas drawImage: 	surf asForm  at: 0@0
! !

!AthensSurfaceExamples classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 9/14/2011 15:42'!
example3
" 
 self example3 
"

	| surf |
	
	surf := AthensBalloonSurface new
		form: (Form extent: 400@400 depth: 32).
	
	surf drawDuring: [:can | | transform path |
	
		can setPaint: Color blue.

		can pathTransform translateX: 200 Y: 200.	
		can pathTransform scaleBy: 6.
		transform := can pathTransform copy.
		path := can createPath: [:pathbuilder |
				pathbuilder 
					absolute;
					moveTo: -25 @ -25;
					curveVia: 25@ -25 to: 25@25;
					curveVia: -25@25 to: -25@ -25
			].
		
		1 to: 1000 do: [:i |
		
				can setPaint: Color random.
		can pathTransform: transform copy.
		can pathTransform rotateByDegrees: i*5.
		can pathTransform scaleBy: (1- ( i/2000)).
"		surf clearForm."
		can drawShape: path.
		Display getCanvas drawImage: 	surf form  at: 0@0. 

		]	
	].
! !

!AthensSurfaceExamples classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 4/29/2011 00:18'!
example3_1
" 
 self example3_1

tesselerate bezier curves to generate lines.

"

	| points tess poly bc |
	
	
	points :=  {	0 @ 60. 600@100. 0 @ 640. }.

	tess := AthensBezier2Tesselerator new.
	

	bc := Display getCanvas asBalloonCanvas.
	bc aaLevel: 4.

	poly := tess generatePolyFrom: points.
	poly add: 0@60.
	
	bc drawPolygon: poly asArray fillStyle: Color red borderWidth: 1 borderColor: Color green. 

	poly do: [:pt |
		bc point: pt color: Color black.
		].
	
	^ poly! !

!AthensSurfaceExamples classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 4/28/2011 16:49'!
example3_2
" 
 self example3_2

tesselerate bezier curves to generate lines.

"

	| points tess poly bc |
	
	tess := AthensBezier2Tesselerator new.
	
	points := {
			0 @ 0. 
			400@100.
			0 @ 200.

			0 @ 200.
			0 @ 0.
			0 @0.
		}.

"	poly := tess generatePolyFrom: points.
"	
	bc := Display getCanvas asBalloonCanvas.
	bc aaLevel: 4.
	
	^[
	100 timesRepeat: [ bc drawBezierShape: points color: Color red borderWidth: 1 borderColor: Color green. ]] timeToRun! !

!AthensSurfaceExamples classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 4/28/2011 16:56'!
example3_3
" 
 self example3_1

tesselerate bezier curves to generate lines.

"

	| points tess poly bc |
	
	points :=  {	0 @ 0. 100@100. 0 @ 200. }.
	tess := AthensBezier2Tesselerator new.
	^ poly := tess generatePolyFrom: points.
! !

!AthensSurfaceExamples classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 9/27/2011 15:06'!
example3stroke
" 
 self example3stroke 
"

	| surf |
	
	surf := AthensBalloonSurface new
		form: (Form extent: 400@400 depth: 32).
	
	surf drawDuring: [:can | | transform path |
	
		(can setStrokePaint: Color blue) width: 1.

		can pathTransform translateX: 200 Y: 200.	
		can pathTransform scaleBy: 8.
		transform := can pathTransform copy.
		path := can createPath: [:pathbuilder |
				pathbuilder 
					absolute;
					moveTo: -25 @ -25;
					curveVia: 25@ -25 to: 25@25;
					curveVia: -25@25 to: -25@ -25
			].
		
		1 to: 1000 do: [:i |
		
				(can setStrokePaint: Color random) width: 1.
				can pathTransform: transform copy.
				can pathTransform rotateByDegrees: i*5.
				can pathTransform scaleBy: (1- ( i/2000)).
	"	surf clearForm."
	
		can drawShape: path.
		Display getCanvas drawImage: 	surf form  at: 0@0. 

		]	
	].
! !

!AthensSurfaceExamples classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 9/14/2011 15:43'!
example4
	" 
	This example demostrates that same path could be reused multiple times when drawing.
	First, we creating a path, and later we can use it in #drawShape: command.
	"

	| surf path |
	
	surf := AthensBalloonSurface new
		form: (Form extent: 100@100 depth: 32).
	
	path :=  surf createRectanglePath: (0@ 0 corner: 20@ 20).
	
	surf drawDuring: [:can |
		surf clearForm.
		can pathTransform loadIdentity.
		can setPaint: (Color red).
		can pathTransform translateX: 5 Y: 5.
		can drawShape: path.
		can setPaint: (Color blue).
		can pathTransform translateX: 5 Y: 5.
		can drawShape: path.
	].
	Display getCanvas drawImage: 	surf form  at: 0@0
! !

!AthensSurfaceExamples classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/21/2011 13:56'!
example5
" draw a hollow rectangle using lineTo/moveTo commands,
 with path, consisting of two contours: outer and inner one.

Note how #moveTo: command implicitly starts new contour
when inssued in the middle of command chain.
"

	| surf |
	
	surf := AthensBalloonSurface new
		form: (Form extent: 100@100 depth: 32).
	
	surf drawDuring: [:can |
		surf clearForm.
		
		can setPaint: Color blue.
		
		can drawShape: (
			can createPath: [:path |
				path 
					absolute;
					lineTo: 50@0;
					lineTo: 50@50;
					lineTo: 0@50;
					moveTo: 10@10;
					lineTo: 40@10;
					lineTo: 40@40;
					lineTo: 10@40
			])
	
	].

	Display getCanvas drawImage: 	surf form  at: 0@0
! !

!AthensSurfaceExamples classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 9/19/2011 15:39'!
example6
"Draw two rectangles, filled by linear gradient. 

Note that it should produce same rectangles with exact same fills, because gradient paint 
coordinates are affected by pathTransform matrix.


self example6
"

	| surf paint |
	
	surf := AthensBalloonSurface new
		form: (Form extent: 100@100 depth: 32).
	
	paint := surf 
		createLinearGradient: { 0->Color red .  1->Color green } 
		origin: 0@0 
		corner: 50@50.
	
	surf drawDuring: [:can |
		surf clearForm.
		
		can setPaint: paint.

		can drawShape: (0@0 corner: 50@50).
		
		can pathTransform translateX: 50 Y: 50.
		can drawShape: (0@0 corner: 50@50).
		
	].

	Display getCanvas drawImage: 	surf form  at: 0@0
! !

!AthensSurfaceExamples classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 9/14/2011 17:19'!
example6stroke
"
self example6stroke


Draw two rectangles, stoked by linear gradient. 

Note that it should produce same rectangles with exact same fills, because gradient paint 
coordinates are affected by pathTransform matrix.
"

	| surf paint |
	
	surf := AthensBalloonSurface new
		form: (Form extent: 100@100 depth: 32).
	
	paint := surf 
		createLinearGradient: { 0->Color red .  1->Color green } 
		origin: 0@0 
		corner: 50@50.
	
	surf drawDuring: [:can |
		surf clearForm.
		
		can setStrokePaint: paint.

		can drawShape: (0@0 corner: 50@50).
		
		can pathTransform translateX: 50 Y: 50.
		can drawShape: (0@0 corner: 50@50).
		
	].

	Display getCanvas drawImage: 	surf form  at: 0@0
! !

!AthensSurfaceExamples classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/21/2011 13:56'!
example7
"Draw two rectangles, filled by linear gradient. 
Rotate the gradient in a loop.

Note that it should produce same rectangles with exact same fills, because gradient paint 
coordinates are affected by pathTransform matrix.
"

	| surf paint |
	
	surf := AthensBalloonSurface new
		form: (Form extent: 100@100 depth: 32).
	
	paint := surf 
		createLinearGradient: { 0->Color red .  1->Color green } 
		origin: 0@0 
		corner: 50@50.
	
	surf drawDuring: [:can |

		1 to: 10000 do: [:i |
			surf clearForm.

			can pathTransform loadIdentity.

			can fillTransform loadIdentity translateX: 15 Y: 15; rotateByDegrees: (i/10000 * 360).		
			can setPaint: paint.

			can drawShape: (0@0 corner: 50@50).
		
			can pathTransform translateX: 50 Y: 50.
			can drawShape: (0@0 corner: 50@50).

			Display getCanvas drawImage: 	surf form  at: 0@0
		].		
	].

! !

!AthensSurfaceExamples classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/21/2011 13:56'!
example8
"Draw two rectangles, filled by radial gradient. 
Rotate the gradient in a loop.

Note that it should produce same rectangles with exact same fills, because gradient paint 
coordinates are affected by pathTransform matrix.
"

	| surf paint |
	
	surf := AthensBalloonSurface new
		form: (Form extent: 200@200 depth: 32).
	
	paint := surf 
		createCircularGradient: { 0->Color red . 1->Color green } 
		center: 100@100
		radius: 100.
	
	surf drawDuring: [:can |
			surf clearForm.

			can pathTransform loadIdentity.
			can setPaint: paint.

			can drawShape: (0@0 corner: 200@200).
		
			Display getCanvas drawImage: 	surf form  at: 0@0
	].

! !

!AthensSurfaceExamples classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/21/2011 13:56'!
example9
"
"

	| surf paint f bf |
	
	surf := AthensBalloonSurface new
		form: (Form extent: 200@200 depth: 32).
	
	surf form getCanvas fillRectangle: surf form boundingBox color: Color white.
	
	f := Form extent: 10@10 depth: 32.
	f getCanvas fillRectangle: (0@0 corner: 5@5) color: (Color red alpha: 0.1).
	f getCanvas fillRectangle: (5@5 corner: 10@10) color: (Color green alpha: 0.1).
surf engine bitBlt combinationRule: 34.
	paint := surf createImagePaint: f.
	
	surf drawDuring: [:can |

			can setPaint: paint.

			can drawShape: (0@0 corner: 100@200).
		
			Display getCanvas drawImage: 	surf form  at: 0@0
	].

! !

!AthensSurfaceExamples classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 9/14/2011 15:36'!
exampleStrokeRect
" 
 self exampleStrokeRect
"

	| surf |
	
	surf := AthensBalloonSurface new
		form: (Form extent: 400@400 depth: 32).
	
	surf drawDuring: [:can | | transform path |
	
		can pathTransform translateX: 200 Y: 200.	
		can pathTransform scaleBy: 8.
		transform := can pathTransform copy.
		
		1 to: 1000 do: [:i |
		
				(can setStrokePaint: Color random) width: 1.
				can pathTransform: transform copy.
				can pathTransform rotateByDegrees: i*5.
				can pathTransform scaleBy: (1- ( i/2000)).
		surf clearForm.
	
		can drawShape: (0@0 corner: 25@25).
		Display getCanvas drawImage: 	surf form  at: 0@0. 

		]	
	].
! !

!AthensSurfaceExamples classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 15:35'!
newSurface:  extent
	self subclassResponsibility! !

!AthensSurfaceExamples classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 4/29/2011 00:45'!
tesselerateBezier2: points 

"tesselerate bezier curve to generate lines "

	^ AthensBezier2Tesselerator new
		generatePolyFrom: points.
! !

Object subclass: #AthensTextComposer
	instanceVariableNames: 'lines text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Text'!

!AthensTextComposer classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/11/2011 16:07'!
scan: aText for: scanner
	^ self new scan: aText for: scanner! !

!AthensTextComposer methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 12:51'!
lines
	^ lines! !

!AthensTextComposer methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/17/2011 12:42'!
renderOn: aCanvas

	| renderer |
	
	renderer := AthensTextRenderer new.
	renderer render: text lines: lines on: aCanvas.
! !

!AthensTextComposer methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/30/2011 19:14'!
scan: aText for: scanner
	" scan text from starting index,
	answer the index of first character for potential next line"
	| index top |	

	text := aText.
	scanner text: text.

	"edge case, text is empty "
	text isEmpty ifTrue: [ ^ scanner ].
	
	scanner newLine: 1.
	index := 1.

	text runs withStartStopAndValueDo: [:start :stop :values |
		
		scanner setAttributes: values.
		start to: stop do: [:i |  | ch |
			ch := text at: i.
			ch = Character cr 
				ifTrue: [ 
					scanner endLine: i - 1.
					scanner newLine: i + 1 ]
				ifFalse: [
					scanner addCharacter: i.
				]
			]
	].
	scanner endLine: (text size).

	lines := scanner lines.

	"set the lines top offset"
	top := 0.
	lines do: [:line |
		line top: top.
		top := top + line height ].
	
! !

Object subclass: #AthensTextDisplayCommand
	instanceVariableNames: 'next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Text'!

AthensTextDisplayCommand subclass: #AthensBackgroundChange
	instanceVariableNames: 'color start width'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Text'!

!AthensBackgroundChange methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/28/2011 14:44'!
addWidth: aWidth
	width := width + aWidth! !

!AthensBackgroundChange methodsFor: 'accessing' stamp: 'IgorStasenko 10/28/2011 14:33'!
color

	^ color! !

!AthensBackgroundChange methodsFor: 'accessing' stamp: 'IgorStasenko 10/28/2011 14:33'!
color: anObject

	color := anObject! !

!AthensBackgroundChange methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/28/2011 14:45'!
initialize
	width :=0.
	color := Color transparent.! !

!AthensBackgroundChange methodsFor: 'rendering' stamp: 'IgorStasenko 11/7/2011 13:42'!
renderOn: renderer
	color isTransparent ifFalse: [
		renderer renderBackground: self
	]! !

!AthensBackgroundChange methodsFor: 'accessing' stamp: 'IgorStasenko 11/7/2011 13:41'!
start
	^ start! !

!AthensBackgroundChange methodsFor: 'accessing' stamp: 'IgorStasenko 11/7/2011 13:41'!
start: aStart
	start := aStart! !

!AthensBackgroundChange methodsFor: 'accessing' stamp: 'IgorStasenko 10/28/2011 14:33'!
width

	^ width! !

!AthensBackgroundChange methodsFor: 'accessing' stamp: 'IgorStasenko 10/28/2011 14:33'!
width: anObject

	width := anObject! !

AthensTextDisplayCommand subclass: #AthensCharacterSpan
	instanceVariableNames: 'start stop'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Text'!

!AthensCharacterSpan methodsFor: 'rendering' stamp: 'IgorStasenko 10/17/2011 12:52'!
renderOn: renderer
	renderer renderCharactersFrom: start to: stop! !

!AthensCharacterSpan methodsFor: 'accessing' stamp: 'IgorStasenko 11/10/2011 10:31'!
splitAt: position
	| newSpan |
	"split receiver on two character spans "
	" position points to first character which should be included in newly created span "
	
	position == start ifTrue: [ ^ self ].
	(position < start or: [ position > stop ]) ifTrue: [ self error: 'invalid position' ].

	newSpan := self class new
		start: position;
		stop: stop.

	stop := position - 1.
	self insert: newSpan.! !

!AthensCharacterSpan methodsFor: 'accessing' stamp: 'IgorStasenko 10/17/2011 12:02'!
start

	^ start! !

!AthensCharacterSpan methodsFor: 'accessing' stamp: 'IgorStasenko 10/17/2011 12:02'!
start: anObject

	start := anObject! !

!AthensCharacterSpan methodsFor: 'accessing' stamp: 'IgorStasenko 10/17/2011 12:02'!
stop

	^ stop! !

!AthensCharacterSpan methodsFor: 'accessing' stamp: 'IgorStasenko 10/17/2011 12:02'!
stop: anObject

	stop := anObject! !

AthensTextDisplayCommand subclass: #AthensColorChange
	instanceVariableNames: 'color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Text'!

!AthensColorChange methodsFor: 'accessing' stamp: 'IgorStasenko 10/11/2011 16:58'!
color

	^ color! !

!AthensColorChange methodsFor: 'accessing' stamp: 'IgorStasenko 10/11/2011 16:58'!
color: anObject

	color := anObject! !

!AthensColorChange methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/17/2011 12:51'!
renderOn: renderer
	renderer setCurrentColor: color! !

AthensTextDisplayCommand subclass: #AthensFontChange
	instanceVariableNames: 'font'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Text'!

!AthensFontChange classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/11/2011 16:55'!
font: aFont 
	^ self new font: aFont! !

!AthensFontChange methodsFor: 'accessing' stamp: 'IgorStasenko 11/10/2011 11:07'!
font
	^ font! !

!AthensFontChange methodsFor: 'accessing' stamp: 'IgorStasenko 10/11/2011 16:55'!
font: aFont
	font := aFont! !

!AthensFontChange methodsFor: 'rendering' stamp: 'IgorStasenko 10/17/2011 12:50'!
renderOn: anAthensTextRenderer 
	anAthensTextRenderer setCurrentFont: font.! !

!AthensTextDisplayCommand methodsFor: 'accessing' stamp: 'IgorStasenko 11/10/2011 10:14'!
addLast: aCommand
	self tail next: aCommand! !

!AthensTextDisplayCommand methodsFor: 'accessing' stamp: 'IgorStasenko 11/10/2011 10:21'!
do: aBlock
	| nn |
	nn := self.
	
	[ nn isNil ] whileFalse: [ 
		aBlock value: nn.
		nn := nn next. ]! !

!AthensTextDisplayCommand methodsFor: 'accessing' stamp: 'IgorStasenko 11/10/2011 10:19'!
insert: aCommands

	| nn |
	nn := next.
	next := aCommands.
	next tail next: nn! !

!AthensTextDisplayCommand methodsFor: 'accessing' stamp: 'IgorStasenko 11/10/2011 10:12'!
next

	^ next! !

!AthensTextDisplayCommand methodsFor: 'accessing' stamp: 'IgorStasenko 11/10/2011 10:12'!
next: anObject
	
	next := anObject! !

!AthensTextDisplayCommand methodsFor: 'copying' stamp: 'IgorStasenko 11/10/2011 10:47'!
postCopy
	"unlink the copy by default"
	next := nil! !

!AthensTextDisplayCommand methodsFor: 'rendering' stamp: 'IgorStasenko 10/30/2011 18:57'!
renderOn: renderer
	self shouldBeImplemented ! !

!AthensTextDisplayCommand methodsFor: 'accessing' stamp: 'IgorStasenko 11/10/2011 10:15'!
tail
	| nn |
	nn := self.
	[ nn next notNil ] whileTrue: [ nn := nn next ].
	^ nn! !

Object subclass: #AthensTextLine
	instanceVariableNames: 'text startIndex endIndex height maxAscent maxDescent width top commands tail'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Text'!

!AthensTextLine methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/10/2011 10:20'!
addCommand: aCommand

	commands 
		ifNil: [ tail := commands := aCommand. ]
		ifNotNil: [ tail next: aCommand ].
	tail := tail tail.
! !

!AthensTextLine methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/28/2011 12:43'!
addWidth: aNumber
	width := width + aNumber.! !

!AthensTextLine methodsFor: 'accessing' stamp: 'IgorStasenko 11/21/2011 12:47'!
bottom
	^ top + self heightAndDescent! !

!AthensTextLine methodsFor: 'accessing' stamp: 'IgorStasenko 10/11/2011 17:19'!
commands

	^ commands! !

!AthensTextLine methodsFor: 'accessing' stamp: 'IgorStasenko 10/11/2011 17:19'!
commands: anObject

	commands := anObject! !

!AthensTextLine methodsFor: 'accessing' stamp: 'IgorStasenko 10/11/2011 17:19'!
endIndex

	^ endIndex! !

!AthensTextLine methodsFor: 'accessing' stamp: 'IgorStasenko 10/11/2011 17:19'!
endIndex: anObject

	endIndex := anObject! !

!AthensTextLine methodsFor: 'accessing' stamp: 'IgorStasenko 10/5/2011 18:04'!
height
	^ height! !

!AthensTextLine methodsFor: 'accessing' stamp: 'IgorStasenko 10/11/2011 17:19'!
height: anObject

	height := anObject! !

!AthensTextLine methodsFor: 'accessing' stamp: 'IgorStasenko 11/7/2011 14:44'!
heightAndDescent

	^ height + maxDescent! !

!AthensTextLine methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/10/2011 10:15'!
initialize
	commands := tail := nil.
	width := height := maxAscent := maxDescent := 0.! !

!AthensTextLine methodsFor: 'accessing' stamp: 'IgorStasenko 10/28/2011 11:00'!
maxAscent
	^ maxAscent! !

!AthensTextLine methodsFor: 'accessing' stamp: 'IgorStasenko 10/28/2011 11:05'!
maxAscent: mascent
	maxAscent := mascent max: maxAscent! !

!AthensTextLine methodsFor: 'accessing' stamp: 'IgorStasenko 11/7/2011 14:36'!
maxDescent
	^ maxDescent! !

!AthensTextLine methodsFor: 'accessing' stamp: 'IgorStasenko 11/7/2011 14:43'!
maxDescent: mascent

	maxDescent := mascent max: maxDescent! !

!AthensTextLine methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/28/2011 12:41'!
maxHeight: aHeight
	height := height max: aHeight! !

!AthensTextLine methodsFor: 'rendering' stamp: 'IgorStasenko 11/10/2011 12:23'!
renderOn: aTextRenderer
	
	commands ifNil: [ ^ self ]. 
	commands do: [ :cmd |
		cmd renderOn: aTextRenderer
	].
! !

!AthensTextLine methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/20/2011 10:30'!
renderOn: anAthensTextRenderer x: aSmallInteger y: aSmallInteger3 
	self shouldBeImplemented.! !

!AthensTextLine methodsFor: 'accessing' stamp: 'IgorStasenko 10/11/2011 17:19'!
startIndex

	^ startIndex! !

!AthensTextLine methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/11/2011 16:10'!
startIndex: index
	startIndex := index! !

!AthensTextLine methodsFor: 'accessing' stamp: 'IgorStasenko 10/11/2011 17:19'!
text

	^ text! !

!AthensTextLine methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/11/2011 16:48'!
text: aText 
	text := aText! !

!AthensTextLine methodsFor: 'accessing' stamp: 'IgorStasenko 11/21/2011 12:47'!
top
	^ top! !

!AthensTextLine methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/5/2011 18:05'!
top: aTop
	top := aTop! !

!AthensTextLine methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/5/2011 18:04'!
width
	^ width! !

!AthensTextLine methodsFor: 'accessing' stamp: 'IgorStasenko 10/11/2011 17:19'!
width: anObject

	width := anObject! !

Object subclass: #AthensTextRenderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Text'!

!AthensTextRenderTest classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/17/2011 14:34'!
test1
	|  t  c surf |

t := '
AthensTextRenderTest test1

leftFlush
p := MultiNewParagraph new.

p compose: t
	style: TextStyle default
	from: 1
	in: (0@0 corner: 100@100).
p

MultiNewParagraph
TextStyle default alignment


globalBounds:  toLocal: 
' 
asText .

	t addAttribute: (TextColor new color: Color red) from: 3 to: 10.
	t addAttribute: (TextEmphasis italic) from: 5 to: 13.

	c := AthensTextComposer scan: t for: AthensTextScanner new.

	surf := AthensBalloonSurface new form: (Form extent: Display extent depth: 32).

	surf drawDuring: [ :canvas | 
		canvas pathTransform scaleBy: 0.8.
		
		c renderOn: canvas
	].

	Display getCanvas translucentImage: surf form at: 0@0

! !

!AthensTextRenderTest classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 18:11'!
test2
	|  t  c surf |
	t := self testText. 
	t addAttribute: (AthensTextBackground new color: (Color green alpha: 0.3 )) from: 1 to: 267.

	c := AthensTextComposer scan: t for: AthensTextScanner new.

	surf := AthensBalloonSurface new form: (Form extent: Display extent depth: 32).

	surf drawDuring: [ :canvas | 
		
		canvas setPaint: (Color white ).
		canvas drawShape: (0@0 corner: 300@300).
		canvas pathTransform scaleBy: 1.

		canvas pathTransform translateX: 300 Y: 0.

		canvas setPaint: Color yellow.
		canvas pathTransform rotateByDegrees: 0.
		c renderOn: canvas
	].

	Display getCanvas translucentImage: surf form at: 0@0

! !

!AthensTextRenderTest classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/25/2011 14:52'!
test3
	|  t  c surf |

"t := '12345 pi kl mn op gj the text must flow' "

t := 'qW' 
asText .
	t addAttribute: (TextFontReference toFont: (
LogicalFont
 familyName: 'Arial'
 pointSize: 8
)).

	c := AthensTextComposer scan: t for: AthensTextScanner new.

	surf := AthensBalloonSurface new form: (Form extent: Display extent depth: 32).

	surf drawDuring: [ :canvas | 
		
		canvas setPaint: (Color yellow alpha: 0.5).
		canvas drawShape: (0@0 corner: 300@300).

		canvas pathTransform translateBy: 200@200.
				
"		canvas pathTransform rotateByDegrees: 90. "
		canvas pathTransform scaleBy: 4.
	1 to: 10 do: [:i |
		
		canvas setPaint: (Color blue alpha: 0.5).
		canvas drawShape: (0@0 corner: 100@10).
		
		c renderOn: canvas.
		
		canvas pathTransform rotateByDegrees: 5. 
		canvas pathTransform translateBy: 0 @11 .
	].
	].
	Display getCanvas translucentImage: surf form at: 100@100

! !

!AthensTextRenderTest classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/25/2011 19:22'!
test4
	|  t  c surf |

"t := '12345 pi kl mn op gj the text must flow' "

t := 'Unfortunately this class has not been documented yet.' 
asText .
	t addAttribute: (TextFontReference toFont: (
LogicalFont
 familyName: 'Tahoma'
 pointSize: 10
)).
	t addAttribute: (TextColor new color: Color red) from: 3 to: 10.


	c := AthensTextComposer scan: t for: AthensTextScanner new.

	surf := AthensBalloonSurface new form: (Form extent: Display extent depth: 32).

	surf drawDuring: [ :canvas | 
		
		canvas setPaint: (Color yellow alpha: 0.5).
		canvas drawShape: (0@0 corner: 300@300).

		canvas pathTransform scaleBy: 1.
		1 to: 20 do: [:i |
			c renderOn: canvas.
			canvas pathTransform translateBy: 0.1@10.
		]
	].
	Display getCanvas translucentImage: surf form at: 100@100

! !

!AthensTextRenderTest classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/25/2011 19:32'!
test5
	|  t  c surf |

"t := '12345 pi kl mn op gj the text must flow' "

t := 'U' 
asText .
	t addAttribute: (TextFontReference toFont: (
LogicalFont
 familyName: 'Tahoma'
 pointSize: 10
)).
	c := AthensTextComposer scan: t for: AthensTextScanner new.

	surf := AthensBalloonSurface new form: (Form extent: Display extent depth: 32).

	surf drawDuring: [ :canvas | 
		
		canvas setPaint: (Color yellow alpha: 0.5).
		canvas drawShape: (0@0 corner: 300@300).

		canvas pathTransform scaleBy: 1.
		1 to: 20 do: [:i |
			c renderOn: canvas.
			canvas pathTransform translateBy: 10@0.1.
		]
	].
	Display getCanvas translucentImage: surf form at: 100@100

! !

!AthensTextRenderTest classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/19/2011 14:39'!
testBlitting
	| fnt form blt |

	fnt := LogicalFont
	 familyName: 'Arial'
 	pointSize: 24.

	form := fnt realFont
		glyphOf: $W
				destDepth: 8
				colorValue: 1
				subpixelPosition: 0.


	blt := BitBlt toForm: Display.
	
	blt 
		sourceForm: form;
		destOrigin: 0@0;
		sourceOrigin: 0@0;
		halftoneForm: nil;
		combinationRule: 41;
		width: form width;
		height: form height;
		
		copyBitsColor: 0
		alpha: 255
		gammaTable:  FreeTypeSettings current gammaTable
		ungammaTable: FreeTypeSettings current gammaInverseTable.
		
"	blt copyForm: form to: 100@100 rule: 41."
	Display forceToScreen.
	
"
	Display getCanvas translucentImage: form at: 0@0.		

"
	
	
! !

!AthensTextRenderTest classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/10/2011 12:06'!
testText
	|  t  |

t := 'The safety constraint is that the garbage collector 
MUST NOT collect any storage that then becomes needed to continue correct execution of the program. Should weak references 
be added, then garbage collection decisions become observable. 
Based on a suggestion from Cameron McCormack, we state the 
safety constraint as follows: So long as operational semantics of 
the remainder of the program execution includes the possibility that 
a reference to an object X may be dereferenced, then X MUST NOT 
be collected. Thus, the garbage collector is allowed to ignore any 
references that remain present in the semantic state, but which it 
can ascertain will never be dereferenced in any possible execution. 
This sets an upper bound on what state MAY be collected. Put 
another way, if the garbage collector ever reports that X has been 
collected, such as by nullifying a weak reference to X, if operational 
semantics of remaining execution requires the traversal of a strong 
(non-weak) reference to X, then the previous report demonstrates a 
safety violation. 
' 
asText .
	t addAttribute: (TextFontReference toFont: (
LogicalFont
 familyName: 'Arial'
 pointSize: 8
)).
	t addAttribute: (TextEmphasis italic) from: 5 to: 100.
	t addAttribute: (TextColor new color: (Color red)) from: 10 to: 60.
	t addAttribute: (TextEmphasis italic) from: 145 to: 200.
	t addAttribute: (TextColor new color: Color green) from: 230 to: 360.

	t addAttribute: (
		TextFontReference toFont: ( LogicalFont familyName: 'Tahoma'  pointSize: 14)) from: 98 to: 200.

	^ t! !

!AthensTextRenderTest classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 16:25'!
testWindow

	^ (AthensPluggableTextMorph
		on: self
		text: #testText
		accept: nil) embeddedInMorphicWindowLabeled: 'A fancy looking title text'
! !

!AthensTextRenderTest classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/22/2011 11:45'!
testWindowRender
	| surf |
	surf := AthensBalloonSurface new form: (Form extent: Display extent depth: 32).

	surf drawDuring: [ :canvas | 
		
		canvas pathTransform scaleBy: 0.5.
		canvas fullDrawMorph: self testWindow.

	].

	Display getCanvas translucentImage: surf form at: 0@0

! !

Object subclass: #AthensTextRenderer
	instanceVariableNames: 'text font canvas glyphRenderer color advance maxAscent currentLine'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Text'!

!AthensTextRenderer commentStamp: 'IgorStasenko 10/20/2011 10:14' prior: 0!
This is a text renderer, which pipelining a text command(s) , produced by AthensTextComposer
into a concrete calls to canvas.

Its using a glyph renderer instance(s) to draw separate font glyphs on a surface in a most suitable/efficient
manner for given Athens surface.
!

!AthensTextRenderer methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/20/2011 13:07'!
initialize
	color := Color black.! !

!AthensTextRenderer methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 18:11'!
render: aText lines: lines on: aCanvas
	| pos tr |
	text := aText.
	canvas := aCanvas.
	pos := canvas pathTransform copy.
	
	
	lines do: [:line | | origY |
		currentLine := line.
		advance := 0@0.
		maxAscent := line maxAscent.
		line renderOn: self.
		canvas pathTransform translateX: 0 Y: line heightAndDescent.

	].
	canvas pathTransform: pos.! !

!AthensTextRenderer methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/7/2011 14:44'!
renderBackground: bkObj
"self halt."
	canvas setPaint: bkObj color.
	canvas drawShape: ( bkObj start@0 corner: bkObj start + bkObj width @ currentLine heightAndDescent)
! !

!AthensTextRenderer methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/7/2011 14:41'!
renderBackground: aColor width: w
"self halt."
	canvas setPaint: aColor.
	canvas drawShape: ( advance x@0 corner: advance x + w +1@ currentLine heightAndDescent)
! !

!AthensTextRenderer methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/25/2011 18:31'!
renderCharactersFrom: start to: stop

	glyphRenderer renderGlyphsIn: text from: start to: stop.
	" retrieve a cumulative horizontal advance"
	advance := glyphRenderer getAdvance.! !

!AthensTextRenderer methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/20/2011 15:54'!
setCurrentColor: aColor

	color = aColor ifTrue: [ ^ self ].
	color := aColor.
	canvas setPaint: aColor.
	glyphRenderer ifNotNil:  [ glyphRenderer setColor: aColor ].! !

!AthensTextRenderer methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/28/2011 11:19'!
setCurrentFont: aFont
	font := aFont.
	glyphRenderer := font glyphRendererOn: canvas surface.
	glyphRenderer 
		setPosition: 0@0 advance: advance baseline: maxAscent;
		setColor: color.! !

Object subclass: #AthensTextScanner
	instanceVariableNames: 'paragraph text currentLine lines currentAttributes currentFont currentColor textStyle currentStrip currentBackground'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Text'!

!AthensTextScanner methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/10/2011 12:00'!
addCharacter: position
	| charWidth fnt |

	currentStrip ifNil: [

		self applyAttributes.
		
		fnt := currentFont font.
		currentLine maxAscent: fnt getPreciseAscent.
		currentLine maxDescent: fnt getPreciseDescent.
		currentLine maxHeight: fnt getPreciseHeight.
		
		currentStrip := AthensCharacterSpan new.
		currentLine addCommand: currentStrip.
		currentStrip start: position.
	].
	
	charWidth := currentFont font getGlyphWidth: (text at: position).
	currentLine addWidth: charWidth.
	currentBackground ifNotNil: [
		currentBackground addWidth: charWidth ].
	
	currentStrip stop: position.
! !

!AthensTextScanner methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/10/2011 11:26'!
addCommand: aCommand
	currentLine addCommand: aCommand! !

!AthensTextScanner methodsFor: 'text attributes' stamp: 'IgorStasenko 11/10/2011 11:14'!
addEmphasis: emphasis
	| fnt |
	
	fnt := currentFont ifNil: [ self defaultFont ] ifNotNil: [ currentFont font ].
	
	self setActualFont: (fnt emphasized: emphasis)! !

!AthensTextScanner methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/10/2011 11:58'!
applyAttributes
	currentAttributes do: [:attr |
		attr emphasizeScanner: self ]. 
	
	currentFont ifNil: [ self setActualFont: self defaultFont ].
	currentColor ifNil: [ self textColor: self defaultColor ].
	! !

!AthensTextScanner methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/10/2011 11:13'!
defaultColor
	^ Color black! !

!AthensTextScanner methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/10/2011 11:13'!
defaultFont

	^ self textStyle defaultFont! !

!AthensTextScanner methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/11/2011 16:53'!
defaultTextStyle

	^ TextStyle default! !

!AthensTextScanner methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/11/2011 17:19'!
endLine: index

	currentLine  endIndex: index! !

!AthensTextScanner methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/10/2011 11:54'!
initialize
	lines := OrderedCollection new.
	currentAttributes := #().! !

!AthensTextScanner methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/17/2011 12:45'!
lines
	^ lines! !

!AthensTextScanner methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/10/2011 12:21'!
newLine: startingIndex 

	currentLine := lines add: (AthensTextLine new text: text;
		startIndex: startingIndex; yourself).

"	currentStrip ifNotNil: [
		
		currentLine addCommand: currentFont copy.
		currentLine addCommand: currentColor copy.

		currentBackground ifNotNil: [
			currentBackground := currentBackground copy start: 0; width: 0. 
			currentLine addCommand: currentBackground ].
	].
"
"reset everything, to make sure all attributes will be reapplied for new line"
	
	currentColor := currentBackground := currentFont := currentStrip := nil.! !

!AthensTextScanner methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/28/2011 14:58'!
resetBackground
	self textBackground: Color transparent.! !

!AthensTextScanner methodsFor: 'text attributes' stamp: 'IgorStasenko 11/10/2011 12:04'!
setActualFont: aFont

	currentFont ifNil: [
		
		currentFont := AthensFontChange new font: aFont.
		self addCommand: currentFont.
		^ self 
	].

	aFont = currentFont font ifFalse: [
		currentFont := AthensFontChange new font: aFont.
		self addCommand: currentFont.
	].
! !

!AthensTextScanner methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/10/2011 12:13'!
setAttributes: anArray 
	currentBackground := nil.
	currentAttributes := anArray.
	
	"we should reset character string here"
	currentStrip := nil.
! !

!AthensTextScanner methodsFor: 'text attributes' stamp: 'IgorStasenko 10/11/2011 16:52'!
setFont: fontNumber

	self setActualFont: (self textStyle fontAt: fontNumber).
	
	! !

!AthensTextScanner methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/11/2011 16:08'!
text: aText 
	text := aText! !

!AthensTextScanner methodsFor: 'text attributes' stamp: 'IgorStasenko 11/10/2011 11:31'!
textBackground: aColor

	"background is transparent by default "
	
	(currentBackground notNil and: [ currentBackground color = aColor ])
		ifTrue: [ ^ self].
		
	currentBackground ifNil: [ aColor isTransparent ifTrue: [ ^ self ] ].
	
	currentBackground := AthensBackgroundChange new color: aColor.
	currentBackground start: currentLine width.
	currentLine addCommand: currentBackground.! !

!AthensTextScanner methodsFor: 'text attributes' stamp: 'IgorStasenko 11/10/2011 11:15'!
textColor: aColor

	currentColor ifNil: [
		currentColor := AthensColorChange new color: aColor.
		self addCommand: currentColor.
		^ self 
	].

	currentColor color = aColor ifFalse: [
		currentColor := AthensColorChange new color: aColor.
		self addCommand: currentColor.	
	].
	! !

!AthensTextScanner methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/11/2011 16:53'!
textStyle
	^ textStyle ifNil: [ textStyle := self defaultTextStyle ]! !

Object subclass: #AthensTransform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Core'!

!AthensTransform commentStamp: 'IgorStasenko 3/26/2011 01:17' prior: 0!
A receiver represents an coordinate system transformation defined by 3x3 matrix of following kind:

| sx   shx   x   |
| shy sy     y   |
|  w0  w1  w2 |

sx and sy define scaling in the x and y directions, respectively;
shx and shy define shearing in the x and y directions, respectively;
tx and ty define translation in the x and y directions, respectively.

AthensSurface are responsible for providing specific implementation 
of me, which is most appropriate for backend its using.

My subclasses should implement a common protocol for applying generic types of affine transformations
on coordinate system:
- translate
- rotate
- shear
- scale
- matrix multiply
- matrix load

Surface must support 4 kinds of transformations of coordinate system(s):
- path-to-surface (#pathTransform) to transform path coordinates to surface space
- image-to-surface (#imageTransform) to transform between user coordinates and surface pixels

- fill-paint-to-user (#fillTransform)
- stroke-paint-to-user (#strokeTransform)

Given a (fill or stroke) paint-to-user transformation Tp and user-to-surface transformation Tu, the paint color and alpha of a pixel to be drawn with surface coordinates (x, y) is defined by mapping its center point (x + 1/2, y + 1/2) through the inverse transformation (Tu * Tp)^-1 , resulting in a sample point in the paint coordinate space.

All transformations, except image-to-surface , ignoring w0 , w1 and w2 values and always assume them set to { 0 , 0 , 1 } respectively.

For accessing a particular kind of transformation, send message to canvas, i.e.:

canvas pathTransform translateBy: 10@10.

It is safe to store transformation in temporary variable, as long as canvas is valid.
!

AthensTransform subclass: #AthensAffineTransform
	instanceVariableNames: 'sx shx x shy sy y'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Matrices'!

!AthensAffineTransform methodsFor: 'transformations' stamp: 'IgorStasenko 10/21/2011 12:55'!
clearTranslation
	"reset a translation from matrix, leaving only scale and rotation"
	
	x := y := 0.0! !

!AthensAffineTransform methodsFor: 'initialize-release' stamp: 'IgorStasenko 3/26/2011 02:09'!
initialize
	self loadIdentity! !

!AthensAffineTransform methodsFor: 'transformations' stamp: 'IgorStasenko 3/26/2011 02:09'!
loadIdentity
	"initialize with identity transform"
	sx := sy := 1.0.
	shx := shy := x := y := 0.0.
	
	! !

!AthensAffineTransform methodsFor: 'transformations' stamp: 'IgorStasenko 3/26/2011 01:46'!
rotateByDegrees: angle


	^ self rotateByRadians: angle degreesToRadians! !

!AthensAffineTransform methodsFor: 'transformations' stamp: 'IgorStasenko 3/26/2011 03:21'!
rotateByRadians: angle

	"multiply receiver by rotation matrix

| sx   shx   x   |        | cos -sin 0  |             | (sx*cos)+(shx*sin)   (-sx*sin+shx*cos)  x |
| shy sy     y   |   *   | sin   cos 0 |   ===> | (shy*cos)+(sy*sin)   (-shy*sin)+sy*cos) y |
|  0     0     1   |       | 0     0   1   |             |        0                                 0                1  |

"
	| cos sin newSx newSy |
	
	cos := angle cos.
	sin := angle sin.
	
	
	newSx := sx*cos + (shx*sin).
	newSy := sy*cos - (shy*sin).
	
	shx := shx*cos - (sx*sin).
	shy := shy*cos + (sy*sin).

	sx := newSx.
	sy := newSy.! !

!AthensAffineTransform methodsFor: 'transformations' stamp: 'IgorStasenko 3/26/2011 01:51'!
scaleBy: factor

	"multiply receiver by uniform scale matrix

| sx   shx   x   |        | f 0 0  |             | sx*f    shx*f  x |
| shy sy     y   |   *   | 0 f 0  |    ===> | shy*f  sy*f   y |
|  0     0     1   |       | 0 0 1  |             |  0      0        1  |

"
	sx := sx*factor.
	shx := shx*factor.
	sy := sy*factor.
	shy := shy*factor.
! !

!AthensAffineTransform methodsFor: 'transformations' stamp: 'IgorStasenko 3/26/2011 01:52'!
scaleX: fx Y: fy

	"multiply receiver by scale matrix

| sx   shx   x   |        | fx 0 0  |              | sx*fx    shx*fx  x |
| shy sy     y   |   *   | 0 fy 0  |    ===> | shy*fy  sy*fy   y |
|  0     0     1   |       | 0 0  1  |              |  0          0        1  |

"
	sx := sx*fx.
	shx := shx*fx.
	sy := sy*fy.
	shy := shy*fy.
! !

!AthensAffineTransform methodsFor: 'accessing' stamp: 'IgorStasenko 10/20/2011 18:48'!
shx
	^ shx! !

!AthensAffineTransform methodsFor: 'accessing' stamp: 'IgorStasenko 10/20/2011 18:48'!
shy
	^ shy! !

!AthensAffineTransform methodsFor: 'accessing' stamp: 'IgorStasenko 10/20/2011 18:48'!
sx
	^ sx! !

!AthensAffineTransform methodsFor: 'accessing' stamp: 'IgorStasenko 10/20/2011 18:48'!
sy
	^ sy! !

!AthensAffineTransform methodsFor: 'vector-transform' stamp: 'IgorStasenko 3/26/2011 03:02'!
transform: aPoint 
	| px py |
	
	px := aPoint x.
	py := aPoint y.
	^ Point 
		x: (sx*px +(shx*py) + x)
		y: (shy*px + (sy*py) + y) ! !

!AthensAffineTransform methodsFor: 'vector-transform' stamp: 'IgorStasenko 3/27/2011 18:40'!
transformX: px Y: py
	" transform x and y coordinates by receiver. Answer a Point"
	^ Point 
		x: (sx*px +(shx*py) + x)
		y: (shy*px + (sy*py) + y) ! !

!AthensAffineTransform methodsFor: 'transformations' stamp: 'IgorStasenko 3/26/2011 03:17'!
translateBy: aPoint

	^ self translateX: aPoint x Y: aPoint y! !

!AthensAffineTransform methodsFor: 'transformations' stamp: 'IgorStasenko 3/26/2011 03:17'!
translateX: px Y: py

" multiply receiver by translation matrix :

| sx   shx   x   |        | 1  0  px |             |	sx  shx  (sx*px + shx*py + x) |
| shy sy     y   |   *   | 0  1  py |   ===> | shy  sy  (shy*px + sy*py + y)  |
|  0     0     1   |       | 0  0   1  |             |  0     0    1  |

"
	x := (sx*px) + (shx*py) + x.
	y := (shy*px) + (sy*py) + y.
! !

!AthensAffineTransform methodsFor: 'transformations' stamp: 'IgorStasenko 10/24/2011 17:24'!
translateX: px y: py

" multiply receiver by translation matrix :

| sx   shx   x   |        | 1  0  px |             |	sx  shx  (sx*px + shx*py + x) |
| shy sy     y   |   *   | 0  1  py |   ===> | shy  sy  (shy*px + sy*py + y)  |
|  0     0     1   |       | 0  0   1  |             |  0     0    1  |

"
	x := (sx*px) + (shx*py) + x.
	y := (shy*px) + (sy*py) + y.
! !

!AthensAffineTransform methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/25/2011 13:20'!
transposed
	
	| s |
	s := shx.
	shx := shy.
	shy := s.! !

!AthensAffineTransform methodsFor: 'accessing' stamp: 'IgorStasenko 10/20/2011 18:48'!
x
	^ x! !

!AthensAffineTransform methodsFor: 'accessing' stamp: 'IgorStasenko 10/20/2011 18:48'!
y
	^ y! !

AthensAffineTransform subclass: #AthensGenericTransform
	instanceVariableNames: 'w0 w1 w2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Matrices'!

!AthensGenericTransform methodsFor: 'transformations' stamp: 'IgorStasenko 3/26/2011 02:10'!
loadIdentity
	"initialize with identity transform"
	super loadIdentity.
	w0 := w1 := 0.0.
	w2 := 1.0! !

AthensTransform subclass: #AthensCairoTransform
	uses: TCairoLibrary
	instanceVariableNames: 'canvas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Cairo'!

AthensCairoTransform class
	uses: TCairoLibrary classTrait
	instanceVariableNames: ''!

!AthensCairoTransform classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 16:49'!
for: cairoCanvas
	^ self new canvas: cairoCanvas! !

!AthensCairoTransform methodsFor: 'initializing' stamp: 'IgorStasenko 12/20/2011 16:43'!
canvas: aCairoCanvas
	canvas := aCairoCanvas! !

!AthensCairoTransform methodsFor: 'transformations' stamp: 'IgorStasenko 12/20/2011 16:47'!
loadIdentity

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(
		void cairo_identity_matrix (AthensCairoCanvas canvas) )

! !

!AthensCairoTransform methodsFor: 'vector-transform' stamp: 'IgorStasenko 12/21/2011 13:43'!
primTransformX: x Y: y

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(
		void cairo_user_to_device (AthensCairoCanvas canvas,
                                                         NBFloatPtr x,
                                                         NBFloatPtr y) )
! !

!AthensCairoTransform methodsFor: 'transformations' stamp: 'IgorStasenko 12/20/2011 16:45'!
rotateByDegrees: angle

	^ self rotateByRadians: angle degreesToRadians! !

!AthensCairoTransform methodsFor: 'transformations' stamp: 'IgorStasenko 12/20/2011 16:45'!
rotateByRadians: angle

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(
		void cairo_rotate (AthensCairoCanvas canvas,
                                                         double angle))

! !

!AthensCairoTransform methodsFor: 'transformations' stamp: 'IgorStasenko 12/20/2011 16:44'!
scaleX: fx Y: fy

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(
		void cairo_scale (AthensCairoCanvas canvas,
                                                         double fx,
                                                         double fy))

! !

!AthensCairoTransform methodsFor: 'vector-transform' stamp: 'IgorStasenko 12/21/2011 13:42'!
transform: aPoint
	| x y |
	"since we use pointers to floats we must create a copy of original values to not scratch them"
	x := aPoint x asFloat shallowCopy.
	y := aPoint y asFloat shallowCopy.
	
	self primTransformX: x Y: y.
	^ x @ y! !

!AthensCairoTransform methodsFor: 'transformations' stamp: 'IgorStasenko 12/20/2011 16:54'!
translateX: px Y: py

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(
		void cairo_translate (AthensCairoCanvas canvas,
                                                         double px,
                                                         double py))

! !

!AthensTransform methodsFor: 'transformations' stamp: 'IgorStasenko 12/20/2011 16:46'!
loadIdentity
	"load the identity matrix into receiver"
	self subclassResponsibility! !

!AthensTransform methodsFor: 'transformations' stamp: 'IgorStasenko 3/26/2011 01:56'!
rotateByDegrees: angle

	self subclassResponsibility! !

!AthensTransform methodsFor: 'transformations' stamp: 'IgorStasenko 3/26/2011 01:55'!
rotateByRadians: angle

	self subclassResponsibility! !

!AthensTransform methodsFor: 'transformations' stamp: 'IgorStasenko 3/26/2011 01:55'!
scaleBy: factor

	self subclassResponsibility! !

!AthensTransform methodsFor: 'transformations' stamp: 'IgorStasenko 3/26/2011 01:55'!
scaleX: fx Y: fy

	self subclassResponsibility! !

!AthensTransform methodsFor: 'vector-transform' stamp: 'IgorStasenko 3/27/2011 18:42'!
transform: aPoint 
	self subclassResponsibility! !

!AthensTransform methodsFor: 'vector-transform' stamp: 'IgorStasenko 3/27/2011 18:42'!
transformX: px Y: py 
	self subclassResponsibility! !

!AthensTransform methodsFor: 'transformations' stamp: 'IgorStasenko 3/26/2011 01:55'!
translateBy: aPoint

	self subclassResponsibility! !

!AthensTransform methodsFor: 'transformations' stamp: 'IgorStasenko 12/21/2011 12:39'!
translateX: px Y: py

	self subclassResponsibility! !

Object subclass: #GlyphRenderer
	instanceVariableNames: 'font'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Text'!

GlyphRenderer subclass: #FT2GlyphRenderer
	instanceVariableNames: 'pixelSize form blt matrix translation penX penY slot surface colorMap bitmapX bitmapY descend origin currentColor hAdvance'
	classVariableNames: ''
	poolDictionaries: 'FT2Constants'
	category: 'Athens-Text'!

!FT2GlyphRenderer classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/20/2011 10:29'!
forFont: aFont surface: aSurface
	^ self new initForFont: aFont surface: aSurface! !

!FT2GlyphRenderer methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/19/2011 15:31'!
clearBitmap
	
	form bits atAllPut: 0.
! !

!FT2GlyphRenderer methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/19/2011 15:37'!
form
	^ form! !

!FT2GlyphRenderer methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/25/2011 18:29'!
getAdvance
	"aPoint is a text origin in user's coordinate system,
	and anvance is accumulated advance came from another renderer instance, expressed in surface's coordinate system"

	| pt |
	pt := (penX/64.0) @ (penY/64.0) - origin.

	^ pt! !

!FT2GlyphRenderer methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 16:32'!
initForFont: aFont surface: aSurface

	self assert: (aFont class == FreeTypeFont).
	
	surface := aSurface.
	font := aFont.
	slot := SimpleTextGlyphInfo new.
	
	pixelSize := font pixelSize rounded.

	blt := BitBlt toForm: surface form.

	self loadSurfaceTransform.

	colorMap := Bitmap new: 256.
	
	blt 
		sourceForm: form;
		sourceX: 0;
		sourceY: 0;
		destOrigin: 0@0;
		sourceOrigin: 0@0;
		halftoneForm: nil;
		combinationRule: 24;
		width: form width;
		height: form height;
		colorMap: colorMap;
		clipRect: surface clipRect.
	
	translation := IntegerArray new: 2.
! !

!FT2GlyphRenderer methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 7/12/2011 20:11'!
loadSlotInfo
	slot loadFrom: font face.! !

!FT2GlyphRenderer methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/7/2011 14:25'!
loadSurfaceTransform
	| m mt org xaxis yaxis sum xmin xmax ymin ymax formW formH fix face bbox |
	
	face := font face.

	face 
		setPixelWidth: pixelSize height: pixelSize.
	
	bbox := face bbox.
	m := surface pathTransform copy transposed.

	org := m transform: 0@0.
	xaxis := (m transform: bbox right - bbox left * pixelSize / face unitsPerEm @ 0) - org.
	yaxis := (m transform: 0 @ (bbox bottom - bbox top * pixelSize / face unitsPerEm)) - org.
	sum := xaxis + yaxis.
	
	xmin := 0 min: ((xaxis x min: yaxis x) min: sum x).
	ymin := 0 min: ((xaxis y min: yaxis y) min: sum y).
	xmax := 0 max: ((xaxis x max: yaxis x) max: sum x).
	ymax := 0 max: ((xaxis y max: yaxis y) max: sum y).

	formW := (xmax - xmin) ceiling + 1.
	formH := (ymax - ymin) ceiling  + 1.

" freetype 'zero' points to bottom-left point on form" 

	"calculate bitmap translation relative to top-left corner of glyph"
	bitmapX := (yaxis x negated + xmin * 64.0) rounded.
	bitmapY := (xaxis y negated + ymin * 64.0) rounded.

	descend := 0 @  ((face bbox height -  face bbox bottom  * pixelSize / face unitsPerEm) +1).
	descend := (m transform: descend) - org.
	descend := descend + (xmin negated@(ymin negated)).
	descend := (descend * 64 ) rounded.

	form := Form extent: formW @ formH depth: 8.

	blt 
		sourceForm: form;
		width: form width;
		height: form height.

	"prepare transformation matrix for freetype"
	
	matrix := IntegerArray new: 4.

	"values in matrix are 16.16 fixed point floating values" 
	fix := 65536. "(2 raisedTo: 16)."
	
	matrix 
		at: 1 put: (m sx * fix) rounded;
		at: 2 put: (m shx * fix) rounded;
		at: 3 put: (m shy * fix) rounded;
		at: 4 put: (m sy * fix) rounded.

! !

!FT2GlyphRenderer methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/25/2011 18:40'!
loadUnicode: unicode

	| ext hintingFlags flags arr face |
	
	face := font face.

"	hintingFlags := FreeTypeSettings current hintingFlags."
	flags :=  LoadNoBitmap bitOr: 2 "hintingFlags".
"	bitOr:( LoadIgnoreTransform  bitOr: 2 ). "
	face primLoadCharacter: unicode flags: flags.

	self loadSlotInfo.
! !

!FT2GlyphRenderer methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/7/2011 13:45'!
renderGlyphsIn: text from: start to: stop
	| face |
	face := font face.
"	face
		setPixelWidth: pixelSize height: pixelSize.
"
	start to: stop do: [:i | | bx by |
		
		bx := penX + bitmapX.
		by := penY + bitmapY.

		"add a small shift, to incorporate subpixel position"
		
		translation at: 1 put: descend x + (bx bitAnd: 2r111111).
		translation at: 2 put: descend y - (by bitAnd: 2r111111). 

		face primSetTransform: matrix delta: translation.

		self loadUnicode: (text at: i) asUnicode.
	
		self clearBitmap.
		face renderGlyphIntoForm: form.

		blt
			destX: bx >> 6;
			destY: by >> 6;
			copyBits.

	"increment x by horizontal advance"
		penX := penX + slot advanceX.
		penY := penY - slot advanceY.

	].

! !

!FT2GlyphRenderer methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/7/2011 13:59'!
setColor: color
	"Set the color which will be used to render glyphs."
	
	| clr rgb alpha |
	currentColor = color ifTrue: [ ^ self ].
	currentColor := color.
	clr := color pixelValue32.
	rgb := clr bitAnd: 16rFFFFFF.
	alpha := clr >> 24.
	
 	0 to: 255 do:[:i | | a |
		a :=  (i+1) * alpha bitAnd: 16rFF00.
		colorMap at: i+1 put: ( (a<<16) + rgb ).
	].

"	colorMap at: 1 put: (Color red  alpha: 0.1) pixelValue32."
! !

!FT2GlyphRenderer methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 16:23'!
setPosition: aPoint 

	^ self setPosition: aPoint advance: 0@0 baseline: font getPreciseAscent.
! !

!FT2GlyphRenderer methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/21/2011 16:23'!
setPosition: aPoint advance: advancePt

	^ self setPosition: aPoint advance: advancePt baseline: font getPreciseAscent.
! !

!FT2GlyphRenderer methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/7/2011 13:45'!
setPosition: aPoint advance: advancePt baseline: baselineOffset
	"aPoint is a text origin in user's coordinate system,
	and andvance is accumulated advance came from another renderer instance, expressed in surface's coordinate system"

	| pt offset |
	
	offset :=  baselineOffset - font getPreciseAscent "(font face ascender  * pixelSize / font face unitsPerEm)".

	pt := aPoint + (0@offset).
	pt := surface pathTransform transform: pt.
	origin := pt.
	pt := pt + advancePt.
	
	"remember the origin, so on #getAdvance , we will answer the current advance for renderer in surface coordinate system"
	
"	2 raisedTo: 6 "
	penX := (pt x * 64) rounded.
	penY := (pt y * 64) rounded.

! !

!GlyphRenderer classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 7/12/2011 19:45'!
forFont: aFont
	^ self basicNew initForFont: aFont! !

!GlyphRenderer classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 7/12/2011 19:26'!
test

	| fnt glyph |
	
	fnt := StandardFonts defaultFont.
	fnt class == LogicalFont ifTrue: [
		fnt := fnt realFont.
		].
	fnt class ~~ FreeTypeFont ifTrue: [ self error: 'invalid font' ].
	
	glyph := self  new initPixelSize: fnt pixelSize.
	
	glyph renderGlyph: $A asUnicode face: fnt face.
	glyph renderGlyph: $B asUnicode face: fnt face.
	glyph renderGlyph: $C asUnicode face: fnt face.
	glyph renderGlyph: $+ asUnicode face: fnt face.
	
	glyph drawOn: Display at: 0@0! !

!GlyphRenderer methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 7/12/2011 19:45'!
initForFont: aFont

	self subclassResponsibility ! !

!LabelMorph methodsFor: '*Athens' stamp: 'IgorStasenko 4/21/2011 17:15'!
drawOnAthensCanvas: aCanvas
	"Draw based on enablement."
	
	|pc|
	pc := self owner
		ifNil: [self paneColor]
		ifNotNil: [self owner color isTransparent
					ifTrue: [self owner paneColor]
					ifFalse: [self owner color]].
	self enabled
		ifTrue: [aCanvas
					drawString: self contents
					in: self bounds
					font: self fontToUse
					color: self color]
		ifFalse: [self disabledStyle == #inset ifTrue: [
					aCanvas
						drawString: self contents
						in: (self bounds translateBy: 1)
						font: self fontToUse
						color: pc lighter;
						drawString: self contents
						in: self bounds
						font: self fontToUse
						color: pc muchDarker].
				self disabledStyle == #plain ifTrue: [	
					aCanvas
						drawString: self contents
						in: self bounds
						font: self fontToUse
						color: pc muchDarker]]! !
MatrixTransform2x3 initialize!
AthensBezierConverter initialize!
AthensCairoDefs initialize!
AthensPathBuilder initialize!
